/*	$NetBSD$	*/

/*-
 * Copyright (c) 2010 SHIMIZU Ryo <ryo@nerv.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _ARM_IMX_IMX51_IOMUXREG_H_
#define _ARM_IMX_IMX51_IOMUXREG_H_

/* General Purpose registers */
#define IMX51_IOMUXC_GPR0_REG					0x00000000
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV47			__BIT(0)
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV37			__BIT(1)
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV46			__BIT(2)
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV35			__BIT(3)
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV25			__BIT(4)
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV23			__BIT(5)
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV24			__BIT(6)
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV21			__BIT(7)
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV20			__BIT(8)
# define IMX51_IOMUXC_GPR0_SDMA_TPIU_TRACE_EN			__BIT(9)
# define IMX51_IOMUXC_GPR0_SDMA_EMI_MUX				__BIT(10)
#define IMX51_IOMUXC_GPR1_REG					0x00000004
#define IMX51_IOMUXC_OBSERVE_MUX_0_REG				0x00000008
#define IMX51_IOMUXC_OBSERVE_MUX_1_REG				0x0000000c
#define IMX51_IOMUXC_OBSERVE_MUX_2_REG				0x00000010
#define IMX51_IOMUXC_OBSERVE_MUX_3_REG				0x00000014
#define IMX51_IOMUXC_OBSERVE_MUX_4_REG				0x00000018


/* MUX registers */
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA0_REG			0x0000001c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA1_REG			0x00000020
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA2_REG			0x00000024
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA3_REG			0x00000028
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA4_REG			0x0000002c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA5_REG			0x00000030
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA6_REG			0x00000034
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA7_REG			0x00000038
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA8_REG			0x0000003c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA9_REG			0x00000040
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA10_REG		0x00000044
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA11_REG		0x00000048
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA12_REG		0x0000004c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA13_REG		0x00000050
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA14_REG		0x00000054
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA15_REG		0x00000058
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D16_REG			0x0000005c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D17_REG			0x00000060
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D18_REG			0x00000064
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D19_REG			0x00000068
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D20_REG			0x0000006c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D21_REG			0x00000070
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D22_REG			0x00000074
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D23_REG			0x00000078
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D24_REG			0x0000007c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D25_REG			0x00000080
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D26_REG			0x00000084
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D27_REG			0x00000088
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D28_REG			0x0000008c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D29_REG			0x00000090
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D30_REG			0x00000094
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D31_REG			0x00000098
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A16_REG			0x0000009c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A17_REG			0x000000a0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A18_REG			0x000000a4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A19_REG			0x000000a8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A20_REG			0x000000ac
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A21_REG			0x000000b0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A22_REG			0x000000b4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A23_REG			0x000000b8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A24_REG			0x000000bc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A25_REG			0x000000c0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A26_REG			0x000000c4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A27_REG			0x000000c8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_REG			0x000000cc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_REG			0x000000d0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_REG			0x000000d4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_REG			0x000000d8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_REG			0x000000dc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_REG			0x000000e0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_REG			0x000000e4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS2_REG			0x000000e8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS3_REG			0x000000ec
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS4_REG			0x000000f0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS5_REG			0x000000f4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DTACK_REG		0x000000f8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_REG			0x000000fc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CRE_REG			0x00000100
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DRAM_CS1_REG		0x00000104
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_WE_B_REG		0x00000108
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RE_B_REG		0x0000010c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_ALE_REG		0x00000110
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CLE_REG		0x00000114
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_WP_B_REG		0x00000118
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RB0_REG		0x0000011c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RB1_REG		0x00000120
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RB2_REG		0x00000124
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RB3_REG		0x00000128
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO_NAND_REG		0x0000012c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS0_REG		0x00000130
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS1_REG		0x00000134
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS2_REG		0x00000138
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS3_REG		0x0000013c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS4_REG		0x00000140
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS5_REG		0x00000144
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS6_REG		0x00000148
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS7_REG		0x0000014c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RDY_INT_REG		0x00000150
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D15_REG		0x00000154
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D14_REG		0x00000158
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D13_REG		0x0000015c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D12_REG		0x00000160
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D11_REG		0x00000164
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D10_REG		0x00000168
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D9_REG		0x0000016c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D8_REG		0x00000170
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D7_REG		0x00000174
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D6_REG		0x00000178
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D5_REG		0x0000017c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D4_REG		0x00000180
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D3_REG		0x00000184
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D2_REG		0x00000188
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D1_REG		0x0000018c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D0_REG		0x00000190
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D8_REG			0x00000194
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D9_REG			0x00000198
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D10_REG		0x0000019c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D11_REG		0x000001a0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D12_REG		0x000001a4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D13_REG		0x000001a8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D14_REG		0x000001ac
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D15_REG		0x000001b0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D16_REG		0x000001b4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D17_REG		0x000001b8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D18_REG		0x000001bc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D19_REG		0x000001c0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_VSYNC_REG		0x000001c4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_HSYNC_REG		0x000001c8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D12_REG		0x000001cc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D13_REG		0x000001d0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D14_REG		0x000001d4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D15_REG		0x000001d8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D16_REG		0x000001dc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D17_REG		0x000001e0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D18_REG		0x000001e4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D19_REG		0x000001e8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_VSYNC_REG		0x000001ec
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_HSYNC_REG		0x000001f0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_PIXCLK_REG		0x000001f4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_I2C1_CLK_REG		0x000001f8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_I2C1_DAT_REG		0x000001fc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_AUD3_BB_TXD_REG		0x00000200
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_AUD3_BB_RXD_REG		0x00000204
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_AUD3_BB_CK_REG		0x00000208
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_AUD3_BB_FS_REG		0x0000020c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_MOSI_REG		0x00000210
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_MISO_REG		0x00000214
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_SS0_REG		0x00000218
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_SS1_REG		0x0000021c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_RDY_REG		0x00000220
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_SCLK_REG		0x00000224
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART1_RXD_REG		0x00000228
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART1_TXD_REG		0x0000022c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART1_RTS_REG		0x00000230
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART1_CTS_REG		0x00000234
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART2_RXD_REG		0x00000238
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART2_TXD_REG		0x0000023c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART3_RXD_REG		0x00000240
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART3_TXD_REG		0x00000244
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_OWIRE_LINE_REG		0x00000248
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_REG		0x0000024c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_REG		0x00000250
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_REG		0x00000254
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_REG		0x00000258
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_REG		0x0000025c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_REG		0x00000260
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_REG		0x00000264
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_REG		0x00000268
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_REG		0x0000026c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL5_REG		0x00000270
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_JTAG_DE_B_REG		0x00000274
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_CLK_REG		0x00000278
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DIR_REG		0x0000027c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_STP_REG		0x00000280
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_NXT_REG		0x00000284
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA0_REG		0x00000288
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA1_REG		0x0000028c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA2_REG		0x00000290
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA3_REG		0x00000294
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA4_REG		0x00000298
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA5_REG		0x0000029c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA6_REG		0x000002a0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA7_REG		0x000002a4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_PIN11_REG		0x000002a8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_PIN12_REG		0x000002ac
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_PIN13_REG		0x000002b0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_D0_CS_REG		0x000002b4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_D1_CS_REG		0x000002b8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISPB2_SER_DIN_REG		0x000002bc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISPB2_SER_DIO_REG		0x000002c0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISPB2_SER_CLK_REG		0x000002c4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISPB2_SER_RS_REG		0x000002c8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT0_REG		0x000002cc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT1_REG		0x000002d0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT2_REG		0x000002d4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT3_REG		0x000002d8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT4_REG		0x000002dc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT5_REG		0x000002e0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT6_REG		0x000002e4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT7_REG		0x000002e8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT8_REG		0x000002ec
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT9_REG		0x000002f0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT10_REG		0x000002f4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT11_REG		0x000002f8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT12_REG		0x000002fc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT13_REG		0x00000300
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT14_REG		0x00000304
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT15_REG		0x00000308
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT16_REG		0x0000030c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT17_REG		0x00000310
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT18_REG		0x00000314
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT19_REG		0x00000318
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT20_REG		0x0000031c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT21_REG		0x00000320
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT22_REG		0x00000324
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT23_REG		0x00000328
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_PIN3_REG		0x0000032c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_PIN2_REG		0x00000330
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI_GP1_REG			0x00000334
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI_GP2_REG			0x00000338
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI_GP3_REG			0x0000033c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI2_PIN4_REG		0x00000340
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI2_PIN2_REG		0x00000344
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI2_PIN3_REG		0x00000348
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI2_DISP_CLK_REG		0x0000034c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI_GP4_REG			0x00000350
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT0_REG		0x00000354
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT1_REG		0x00000358
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT2_REG		0x0000035c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT3_REG		0x00000360
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT4_REG		0x00000364
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT5_REG		0x00000368
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT6_REG		0x0000036c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT7_REG		0x00000370
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT8_REG		0x00000374
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT9_REG		0x00000378
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT10_REG		0x0000037c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT11_REG		0x00000380
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT12_REG		0x00000384
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT13_REG		0x00000388
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT14_REG		0x0000038c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT15_REG		0x00000390
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_REG			0x00000394
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_REG			0x00000398
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_REG		0x0000039c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_REG		0x000003a0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_REG		0x000003a4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_REG		0x000003a8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_0_REG			0x000003ac
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_1_REG			0x000003b0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_REG			0x000003b4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_REG			0x000003b8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_REG		0x000003bc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_REG		0x000003c0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_REG		0x000003c4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_REG		0x000003c8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_2_REG			0x000003cc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_3_REG			0x000003d0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_PMIC_INT_REQ_REG		0x000003d4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_4_REG			0x000003d8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_5_REG			0x000003dc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_6_REG			0x000003e0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_7_REG			0x000003e4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_8_REG			0x000003e8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_9_REG			0x000003ec
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT0			0x00000000
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT1			0x00000001
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT2			0x00000002
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT3			0x00000003
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT4			0x00000004
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT5			0x00000005
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT6			0x00000006
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT7			0x00000007
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_SION			__BIT(4)

/* PAD registers */
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D16_REG			0x000003f0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D17_REG			0x000003f4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D18_REG			0x000003f8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D19_REG			0x000003fc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D20_REG			0x00000400
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D21_REG			0x00000404
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D22_REG			0x00000408
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D23_REG			0x0000040c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D24_REG			0x00000410
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D25_REG			0x00000414
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D26_REG			0x00000418
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D27_REG			0x0000041c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D28_REG			0x00000420
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D29_REG			0x00000424
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D30_REG			0x00000428
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D31_REG			0x0000042c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A16_REG			0x00000430
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A17_REG			0x00000434
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A18_REG			0x00000438
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A19_REG			0x0000043c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A20_REG			0x00000440
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A21_REG			0x00000444
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A22_REG			0x00000448
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A23_REG			0x0000044c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A24_REG			0x00000450
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A25_REG			0x00000454
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A26_REG			0x00000458
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A27_REG			0x0000045c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_REG			0x00000460
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_REG			0x00000464
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_REG			0x00000468
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_REG			0x0000046c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_REG			0x00000470
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_REG			0x00000474
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_REG			0x00000478
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS2_REG			0x0000047c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS3_REG			0x00000480
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS4_REG			0x00000484
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS5_REG			0x00000488
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_DTACK_REG		0x0000048c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_REG		0x00000490
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_REG			0x00000494
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_REG		0x00000498
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_REG			0x0000049c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CRE_REG			0x000004a0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_REG		0x000004a4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_REG		0x000004a8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_REG		0x000004ac
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_REG		0x000004b0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_REG		0x000004b4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK_REG		0x000004b8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_REG		0x000004bc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_REG		0x000004c0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_REG		0x000004c4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_REG		0x000004c8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_REG		0x000004cc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_REG		0x000004d0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_REG		0x000004d4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_REG		0x000004d8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_REG		0x000004dc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_REG		0x000004e0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_WE_B_REG		0x000004e4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RE_B_REG		0x000004e8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_ALE_REG		0x000004ec
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CLE_REG		0x000004f0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_WP_B_REG		0x000004f4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RB0_REG		0x000004f8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RB1_REG		0x000004fc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RB2_REG		0x00000500
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RB3_REG		0x00000504
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_SDBA2_REG		0x00000508
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_SDODT1_REG		0x0000050c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_SDODT0_REG		0x00000510
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO_NAND_REG		0x00000514
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS0_REG		0x00000518
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS1_REG		0x0000051c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS2_REG		0x00000520
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS3_REG		0x00000524
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS4_REG		0x00000528
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS5_REG		0x0000052c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS6_REG		0x00000530
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS7_REG		0x00000534
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RDY_INT_REG		0x00000538
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D15_REG		0x0000053c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D14_REG		0x00000540
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D13_REG		0x00000544
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D12_REG		0x00000548
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D11_REG		0x0000054c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D10_REG		0x00000550
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D9_REG		0x00000554
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D8_REG		0x00000558
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D7_REG		0x0000055c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D6_REG		0x00000560
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D5_REG		0x00000564
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D4_REG		0x00000568
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D3_REG		0x0000056c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D2_REG		0x00000570
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D1_REG		0x00000574
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D0_REG		0x00000578
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D8_REG			0x0000057c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D9_REG			0x00000580
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D10_REG		0x00000584
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D11_REG		0x00000588
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D12_REG		0x0000058c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D13_REG		0x00000590
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D14_REG		0x00000594
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D15_REG		0x00000598
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D16_REG		0x0000059c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D17_REG		0x000005a0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D18_REG		0x000005a4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D19_REG		0x000005a8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_VSYNC_REG		0x000005ac
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_HSYNC_REG		0x000005b0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_PIXCLK_REG		0x000005b4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_MCLK_REG		0x000005b8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D12_REG		0x000005bc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D13_REG		0x000005c0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D14_REG		0x000005c4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D15_REG		0x000005c8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D16_REG		0x000005cc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D17_REG		0x000005d0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D18_REG		0x000005d4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D19_REG		0x000005d8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_VSYNC_REG		0x000005dc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_HSYNC_REG		0x000005e0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_PIXCLK_REG		0x000005e4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_I2C1_CLK_REG		0x000005e8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_I2C1_DAT_REG		0x000005ec
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_AUD3_BB_TXD_REG		0x000005f0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_AUD3_BB_RXD_REG		0x000005f4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_AUD3_BB_CK_REG		0x000005f8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_AUD3_BB_FS_REG		0x000005fc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_MOSI_REG		0x00000600
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_MISO_REG		0x00000604
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_SS0_REG		0x00000608
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_SS1_REG		0x0000060c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_RDY_REG		0x00000610
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_SCLK_REG		0x00000614
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART1_RXD_REG		0x00000618
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART1_TXD_REG		0x0000061c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART1_RTS_REG		0x00000620
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART1_CTS_REG		0x00000624
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART2_RXD_REG		0x00000628
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART2_TXD_REG		0x0000062c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART3_RXD_REG		0x00000630
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART3_TXD_REG		0x00000634
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_OWIRE_LINE_REG		0x00000638
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_REG		0x0000063c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_REG		0x00000640
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_REG		0x00000644
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_REG		0x00000648
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_REG		0x0000064c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_REG		0x00000650
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_REG		0x00000654
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_REG		0x00000658
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_REG		0x0000065c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL5_REG		0x00000660
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_REG		0x00000664
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_REG		0x00000668
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_REG		0x0000066c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_REG		0x00000670
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_REG		0x00000674
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_CLK_REG		0x00000678
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DIR_REG		0x0000067c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_STP_REG		0x00000680
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_NXT_REG		0x00000684
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA0_REG		0x00000688
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA1_REG		0x0000068c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA2_REG		0x00000690
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA3_REG		0x00000694
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA4_REG		0x00000698
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA5_REG		0x0000069c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA6_REG		0x000006a0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA7_REG		0x000006a4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN11_REG		0x000006a8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN12_REG		0x000006ac
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN13_REG		0x000006b0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_D0_CS_REG		0x000006b4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_D1_CS_REG		0x000006b8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISPB2_SER_DIN_REG		0x000006bc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISPB2_SER_DIO_REG		0x000006c0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISPB2_SER_CLK_REG		0x000006c4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISPB2_SER_RS_REG		0x000006c8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT0_REG		0x000006cc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT1_REG		0x000006d0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT2_REG		0x000006d4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT3_REG		0x000006d8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT4_REG		0x000006dc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT5_REG		0x000006e0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT6_REG		0x000006e4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT7_REG		0x000006e8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT8_REG		0x000006ec
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT9_REG		0x000006f0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT10_REG		0x000006f4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT11_REG		0x000006f8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT12_REG		0x000006fc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT13_REG		0x00000700
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT14_REG		0x00000704
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT15_REG		0x00000708
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT16_REG		0x0000070c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT17_REG		0x00000710
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT18_REG		0x00000714
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT19_REG		0x00000718
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT20_REG		0x0000071c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT21_REG		0x00000720
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT22_REG		0x00000724
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT23_REG		0x00000728
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN3_REG		0x0000072c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_DISP_CLK_REG		0x00000730
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN2_REG		0x00000734
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN15_REG		0x00000738
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI_GP1_REG			0x0000073c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI_GP2_REG			0x00000740
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI_GP3_REG			0x00000744
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI2_PIN4_REG		0x00000748
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI2_PIN2_REG		0x0000074c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI2_PIN3_REG		0x00000750
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI2_DISP_CLK_REG		0x00000754
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI_GP4_REG			0x00000758
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT0_REG		0x0000075c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT1_REG		0x00000760
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT2_REG		0x00000764
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT3_REG		0x00000768
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT4_REG		0x0000076c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT5_REG		0x00000770
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT6_REG		0x00000774
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT7_REG		0x00000778
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT8_REG		0x0000077c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT9_REG		0x00000780
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT10_REG		0x00000784
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT11_REG		0x00000788
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT12_REG		0x0000078c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT13_REG		0x00000790
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT14_REG		0x00000794
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT15_REG		0x00000798
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_REG			0x0000079c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_REG			0x000007a0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_REG		0x000007a4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_REG		0x000007a8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_REG		0x000007ac
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_REG		0x000007b0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_0_REG			0x000007b4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_1_REG			0x000007b8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_REG			0x000007bc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_REG			0x000007c0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_REG		0x000007c4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_REG		0x000007c8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_REG		0x000007cc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_REG		0x000007d0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_2_REG			0x000007d4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_3_REG			0x000007d8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_RESET_IN_B_REG		0x000007dc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_POR_B_REG			0x000007e0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_BOOT_MODE1_REG		0x000007e4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_BOOT_MODE0_REG		0x000007e8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_PMIC_RDY_REG		0x000007ec
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CKIL_REG			0x000007f0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_PMIC_STBY_REQ_REG		0x000007f4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_PMIC_ON_REQ_REG		0x000007f8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_PMIC_INT_REQ_REG		0x000007fc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CLK_SS_REG			0x00000800
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_4_REG			0x00000804
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_5_REG			0x00000808
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_6_REG			0x0000080c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_7_REG			0x00000810
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_8_REG			0x00000814
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_9_REG			0x00000818
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_CSI2_PKE0_REG		0x0000081c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDRPKS_REG			0x00000820
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_SR1_REG			0x00000824
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DISP2_PKE0_REG		0x00000828
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_B4_REG			0x0000082c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_INDDR_REG			0x00000830
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_SR2_REG			0x00000834
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_PKEDDR_REG			0x00000838
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDR_A0_REG			0x0000083c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EMI_PKE0_REG		0x00000840
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_SR3_REG			0x00000844
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDR_A1_REG			0x00000848
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDRAPUS_REG			0x0000084c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_SR4_REG			0x00000850
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EMI_SR5_REG			0x00000854
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EMI_SR6_REG			0x00000858
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_HYSDDR0_REG			0x0000085c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_CSI1_PKE0_REG		0x00000860
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_HYSDDR1_REG			0x00000864
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DISP1_PKE0_REG		0x00000868
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_HYSDDR2_REG			0x0000086c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_HVDDR_REG			0x00000870
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_HYSDDR3_REG			0x00000874
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_SR_B0_REG		0x00000878
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDRAPKS_REG			0x0000087c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_SR_B1_REG		0x00000880
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDRPUS_REG			0x00000884
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_DS1_REG			0x00000888
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_SR_B2_REG		0x0000088c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_PKEADDR_REG			0x00000890
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_DS2_REG			0x00000894
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_DS3_REG			0x00000898
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_SR_B4_REG		0x0000089c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_INMODE1_REG			0x000008a0
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_B0_REG			0x000008a4
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_DS4_REG			0x000008a8
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_B1_REG			0x000008ac
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDR_SR_A0_REG		0x000008b0
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EMI_DS5_REG			0x000008b4
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_B2_REG			0x000008b8
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDR_SR_A1_REG		0x000008bc
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EMI_DS6_REG			0x000008c0
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_SR_SLOW			0
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_SR_FAST			__BIT(0)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_DS_LOW			(0 << 1)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_DS_MEDIUM			(1 << 1)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_DS_HIGH			(2 << 1)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_DS_MAX			(3 << 1)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_OD_ENABLE			__BIT(3)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS_100K_PULLDOWN		(0 << 4)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS_47K_PULLUP		(1 << 4)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS_100K_PULLUP		(2 << 4)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS_22K_PULLUP		(3 << 4)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PUE			__BIT(6)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PKE			__BIT(7)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_HYS			__BIT(8)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_HVE			__BIT(13)

#define IMX51_IOMUXC_AUDMUX_P4_INPUT_DA_AMX_SELECT_INPUT_REG	0x000008c4
#define IMX51_IOMUXC_AUDMUX_P4_INPUT_DB_AMX_SELECT_INPUT_REG	0x000008c8
#define IMX51_IOMUXC_AUDMUX_P4_INPUT_TXCLK_AMX_SELECT_INPUT_REG	0x000008cc
#define IMX51_IOMUXC_AUDMUX_P4_INPUT_TXFS_AMX_SELECT_INPUT_REG	0x000008d0
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_DA_AMX_SELECT_INPUT_REG	0x000008d4
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_DB_AMX_SELECT_INPUT_REG	0x000008d8
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_RXCLK_AMX_SELECT_INPUT_REG	0x000008dc
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_RXFS_AMX_SELECT_INPUT_REG	0x000008e0
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_TXCLK_AMX_SELECT_INPUT_REG	0x000008e4
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_TXFS_AMX_SELECT_INPUT_REG	0x000008e8
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_DA_AMX_SELECT_INPUT_REG	0x000008ec
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_DB_AMX_SELECT_INPUT_REG	0x000008f0
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_RXCLK_AMX_SELECT_INPUT_REG	0x000008f4
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_RXFS_AMX_SELECT_INPUT_REG	0x000008f8
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_TXCLK_AMX_SELECT_INPUT_REG	0x000008fc
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_TXFS_AMX_SELECT_INPUT_REG	0x00000900
#define IMX51_IOMUXC_CCM_IPP_DI0_CLK_SELECT_INPUT_REG		0x00000904
#define IMX51_IOMUXC_CCM_IPP_DI1_CLK_SELECT_INPUT_REG		0x00000908
#define IMX51_IOMUXC_CCM_PLL1_BYPASS_CLK_SELECT_INPUT_REG	0x0000090c
#define IMX51_IOMUXC_CCM_PLL2_BYPASS_CLK_SELECT_INPUT_REG	0x00000910
#define IMX51_IOMUXC_CSPI_IPP_CSPI_CLK_IN_SELECT_INPUT_REG	0x00000914
#define IMX51_IOMUXC_CSPI_IPP_IND_MISO_SELECT_INPUT_REG		0x00000918
#define IMX51_IOMUXC_CSPI_IPP_IND_MOSI_SELECT_INPUT_REG		0x0000091c
#define IMX51_IOMUXC_CSPI_IPP_IND_SS1_B_SELECT_INPUT_REG	0x00000920
#define IMX51_IOMUXC_CSPI_IPP_IND_SS2_B_SELECT_INPUT_REG	0x00000924
#define IMX51_IOMUXC_CSPI_IPP_IND_SS3_B_SELECT_INPUT_REG	0x00000928
#define IMX51_IOMUXC_DPLLIP1_L1T_TOG_EN_SELECT_INPUT_REG	0x0000092c
#define IMX51_IOMUXC_ECSPI2_IPP_IND_SS_B_1_SELECT_INPUT_REG	0x00000930
#define IMX51_IOMUXC_ECSPI2_IPP_IND_SS_B_3_SELECT_INPUT_REG	0x00000934
#define IMX51_IOMUXC_EMI_IPP_IND_RDY_INT_SELECT_INPUT_REG	0x00000938
#define IMX51_IOMUXC_ESDHC3_IPP_DAT0_IN_SELECT_INPUT_REG	0x0000093c
#define IMX51_IOMUXC_ESDHC3_IPP_DAT1_IN_SELECT_INPUT_REG	0x00000940
#define IMX51_IOMUXC_ESDHC3_IPP_DAT2_IN_SELECT_INPUT_REG	0x00000944
#define IMX51_IOMUXC_ESDHC3_IPP_DAT3_IN_SELECT_INPUT_REG	0x00000948
#define IMX51_IOMUXC_FEC_FEC_COL_SELECT_INPUT_REG		0x0000094c
#define IMX51_IOMUXC_FEC_FEC_CRS_SELECT_INPUT_REG		0x00000950
#define IMX51_IOMUXC_FEC_FEC_MDI_SELECT_INPUT_REG		0x00000954
#define IMX51_IOMUXC_FEC_FEC_RDATA_0_SELECT_INPUT_REG		0x00000958
#define IMX51_IOMUXC_FEC_FEC_RDATA_1_SELECT_INPUT_REG		0x0000095c
#define IMX51_IOMUXC_FEC_FEC_RDATA_2_SELECT_INPUT_REG		0x00000960
#define IMX51_IOMUXC_FEC_FEC_RDATA_3_SELECT_INPUT_REG		0x00000964
#define IMX51_IOMUXC_FEC_FEC_RX_CLK_SELECT_INPUT_REG		0x00000968
#define IMX51_IOMUXC_FEC_FEC_RX_DV_SELECT_INPUT_REG		0x0000096c
#define IMX51_IOMUXC_FEC_FEC_RX_ER_SELECT_INPUT_REG		0x00000970
#define IMX51_IOMUXC_FEC_FEC_TX_CLK_SELECT_INPUT_REG		0x00000974
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_1_SELECT_INPUT_REG	0x00000978
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_2_SELECT_INPUT_REG	0x0000097c
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_3_SELECT_INPUT_REG	0x00000980
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_4_SELECT_INPUT_REG	0x00000984
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_5_SELECT_INPUT_REG	0x00000988
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_6_SELECT_INPUT_REG	0x0000098c
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_7_SELECT_INPUT_REG	0x00000990
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_8_SELECT_INPUT_REG	0x00000994
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_12_SELECT_INPUT_REG	0x00000998
#define IMX51_IOMUXC_HSC_MIPI_MIX_IPP_IND_SENS1_DATA_EN_SELECT_I_REG	0x0000099c
#define IMX51_IOMUXC_HSC_MIPI_MIX_IPP_IND_SENS2_DATA_EN_SELECT_I_REG	0x000009a0
#define IMX51_IOMUXC_HSC_MIPI_MIX_PAR0_VSYNC_SELECT_INPUT_REG	0x000009a4
#define IMX51_IOMUXC_HSC_MIPI_MIX_PAR1_DI_WAIT_SELECT_INPUT_REG	0x000009a8
#define IMX51_IOMUXC_HSC_MIPI_MIX_PAR_SISG_TRIG_SELECT_INPUT_REG	0x000009ac
#define IMX51_IOMUXC_I2C1_IPP_SCL_IN_SELECT_INPUT_REG		0x000009b0
#define IMX51_IOMUXC_I2C1_IPP_SDA_IN_SELECT_INPUT_REG		0x000009b4
#define IMX51_IOMUXC_I2C2_IPP_SCL_IN_SELECT_INPUT_REG		0x000009b8
#define IMX51_IOMUXC_I2C2_IPP_SDA_IN_SELECT_INPUT_REG		0x000009bc
#define IMX51_IOMUXC_IPU_IPP_DI_0_IND_DISPB_SD_D_SELECT_INPUT_REG	0x000009c0
#define IMX51_IOMUXC_IPU_IPP_DI_1_IND_DISPB_SD_D_SELECT_INPUT_REG	0x000009c4
#define IMX51_IOMUXC_KPP_IPP_IND_COL_6_SELECT_INPUT_REG		0x000009c8
#define IMX51_IOMUXC_KPP_IPP_IND_COL_7_SELECT_INPUT_REG		0x000009cc
#define IMX51_IOMUXC_KPP_IPP_IND_ROW_4_SELECT_INPUT_REG		0x000009d0
#define IMX51_IOMUXC_KPP_IPP_IND_ROW_5_SELECT_INPUT_REG		0x000009d4
#define IMX51_IOMUXC_KPP_IPP_IND_ROW_6_SELECT_INPUT_REG		0x000009d8
#define IMX51_IOMUXC_KPP_IPP_IND_ROW_7_SELECT_INPUT_REG		0x000009dc
#define IMX51_IOMUXC_UART1_IPP_UART_RTS_B_SELECT_INPUT_REG	0x000009e0
#define IMX51_IOMUXC_UART1_IPP_UART_RXD_MUX_SELECT_INPUT_REG	0x000009e4
#define IMX51_IOMUXC_UART2_IPP_UART_RTS_B_SELECT_INPUT_REG	0x000009e8
#define IMX51_IOMUXC_UART2_IPP_UART_RXD_MUX_SELECT_INPUT_REG	0x000009ec
#define IMX51_IOMUXC_UART3_IPP_UART_RTS_B_SELECT_INPUT_REG	0x000009f0
#define IMX51_IOMUXC_UART3_IPP_UART_RXD_MUX_SELECT_INPUT_REG	0x000009f4
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_CLK_SELECT_INPUT_REG	0x000009f8
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_0_SELECT_INPUT_REG	0x000009fc
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_1_SELECT_INPUT_REG	0x00000a00
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_2_SELECT_INPUT_REG	0x00000a04
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_3_SELECT_INPUT_REG	0x00000a08
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_4_SELECT_INPUT_REG	0x00000a0c
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_5_SELECT_INPUT_REG	0x00000a10
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_6_SELECT_INPUT_REG	0x00000a14
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_7_SELECT_INPUT_REG	0x00000a18
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DIR_SELECT_INPUT_REG	0x00000a1c
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_NXT_SELECT_INPUT_REG	0x00000a20
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_STP_SELECT_INPUT_REG	0x00000a24
# define IMX51_IOMUXC_DAISY0					0x00000000
# define IMX51_IOMUXC_DAISY1					0x00000001
# define IMX51_IOMUXC_DAISY2					0x00000002
# define IMX51_IOMUXC_DAISY3					0x00000003
# define IMX51_IOMUXC_DAISY4					0x00000004
# define IMX51_IOMUXC_DAISY5					0x00000005
# define IMX51_IOMUXC_DAISY6					0x00000006
# define IMX51_IOMUXC_DAISY7					0x00000007

#define AXI_IOMUXC_MUX(axi, name, mux)					\
	axi_iomux_set(axi, IMX51_IOMUXC_SW_MUX_CTL_PAD_##name##_REG,	\
	    IMX51_IOMUXC_SW_MUX_CTL_PAD_##mux)

#define AXI_IOMUXC_PAD(axi, name, pad)					\
	axi_iomux_set(axi, IMX51_IOMUXC_SW_PAD_CTL_PAD_##name##_REG,	\
	    pad)

#define AXI_IOMUXC_MUXPAD(axi, name, mux, pad)				\
	do {								\
		AXI_IOMUXC_MUX(axi, name, mux);				\
		AXI_IOMUXC_PAD(axi, name, pad);				\
	} while (0 /* CONSTCOND */)

#endif /* _ARM_IMX_IMX51_IOMUXREG_H_ */
