/*	$NetBSD$	*/

/*-
 * Copyright (c) 2010 SHIMIZU Ryo <ryo@nerv.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _ARM_IMX_IMX51_IPUREG_H_
#define _ARM_IMX_IMX51_IPUREG_H_

#define IMX51_IPU_BUFFER_OFFSET		0x00000000	/* = PA:0x40000000 */
#define IMX51_IPU_BUFFER_SIZE		0x01e00000


#define IMX51_IPU_COMMON_OFFSET		0x0e000000	/* = PA:0x4E000000 */
#define IMX51_IPU_COMMON_SIZE		0x00070000
#define IMX51_IPU_COMMON_IPU_CONF_REG				0x00000000
# define IMX51_IPU_COMMON_IPU_CONF_CSI0_EN			__BIT(0)
# define IMX51_IPU_COMMON_IPU_CONF_CSI1_EN			__BIT(1)
# define IMX51_IPU_COMMON_IPU_CONF_IC_EN			__BIT(2)
# define IMX51_IPU_COMMON_IPU_CONF_IRT_EN			__BIT(3)
# define IMX51_IPU_COMMON_IPU_CONF_DP_EN			__BIT(5)
# define IMX51_IPU_COMMON_IPU_CONF_DI0_EN			__BIT(6)
# define IMX51_IPU_COMMON_IPU_CONF_DI1_EN			__BIT(7)
# define IMX51_IPU_COMMON_IPU_CONF_SMFC_EN			__BIT(8)
# define IMX51_IPU_COMMON_IPU_CONF_DC_EN			__BIT(9)
# define IMX51_IPU_COMMON_IPU_CONF_DMFC_EN			__BIT(10)
# define IMX51_IPU_COMMON_IPU_CONF_SISG_EN			__BIT(11)
# define IMX51_IPU_COMMON_IPU_CONF_VDI_EN			__BIT(12)
# define IMX51_IPU_COMMON_IPU_CONF_DIAGBUS_MODE(n)		(((n) & 31) << 16)
# define IMX51_IPU_COMMON_IPU_CONF_DIAGBUS_ON			__BIT(21)
# define IMX51_IPU_COMMON_IPU_CONF_IDMAC_DISABLE		__BIT(22)
# define IMX51_IPU_COMMON_IPU_CONF_IC_DMFC_SEL			__BIT(25)
# define IMX51_IPU_COMMON_IPU_CONF_IC_DMFC_SYNC			__BIT(26)
# define IMX51_IPU_COMMON_IPU_CONF_VDI_DMFC_SYNC		__BIT(27)
# define IMX51_IPU_COMMON_IPU_CONF_CSI0_DATA_SOURCE		__BIT(28)
# define IMX51_IPU_COMMON_IPU_CONF_CSI1_DATA_SOURCE		__BIT(29)
# define IMX51_IPU_COMMON_IPU_CONF_IC_INPUT			__BIT(30)
# define IMX51_IPU_COMMON_IPU_CONF_CSI_SEL			__BIT(31)

#define IMX51_IPU_COMMON_IPU_SISG_CTRL0_REG			0x00000004
#define IMX51_IPU_COMMON_IPU_SISG_CTRL1_REG			0x00000008
#define IMX51_IPU_COMMON_IPU_SISG_SET_1_REG			0x0000000c
#define IMX51_IPU_COMMON_IPU_SISG_SET_2_REG			0x00000010
#define IMX51_IPU_COMMON_IPU_SISG_SET_3_REG			0x00000014
#define IMX51_IPU_COMMON_IPU_SISG_SET_4_REG			0x00000018
#define IMX51_IPU_COMMON_IPU_SISG_SET_5_REG			0x0000001c
#define IMX51_IPU_COMMON_IPU_SISG_SET_6_REG			0x00000020
#define IMX51_IPU_COMMON_IPU_SISG_CLR_1_REG			0x00000024
#define IMX51_IPU_COMMON_IPU_SISG_CLR_2_REG			0x00000028
#define IMX51_IPU_COMMON_IPU_SISG_CLR_3_REG			0x0000002c
#define IMX51_IPU_COMMON_IPU_SISG_CLR_4_REG			0x00000030
#define IMX51_IPU_COMMON_IPU_SISG_CLR_5_REG			0x00000034
#define IMX51_IPU_COMMON_IPU_SISG_CLR_6_REG			0x00000038

#define IMX51_IPU_COMMON_IPU_INT_CTRL_REG(n)			(0x0000003c + (4 * (n)))
#define IMX51_IPU_COMMON_IPU_INT_CTRL_1_REG			0x0000003c
#define IMX51_IPU_COMMON_IPU_INT_CTRL_2_REG			0x00000040
#define IMX51_IPU_COMMON_IPU_INT_CTRL_3_REG			0x00000044
#define IMX51_IPU_COMMON_IPU_INT_CTRL_4_REG			0x00000048
#define IMX51_IPU_COMMON_IPU_INT_CTRL_5_REG			0x0000004c
#define IMX51_IPU_COMMON_IPU_INT_CTRL_6_REG			0x00000050
#define IMX51_IPU_COMMON_IPU_INT_CTRL_7_REG			0x00000054
#define IMX51_IPU_COMMON_IPU_INT_CTRL_8_REG			0x00000058
#define IMX51_IPU_COMMON_IPU_INT_CTRL_9_REG			0x0000005c
#define IMX51_IPU_COMMON_IPU_INT_CTRL_10_REG			0x00000060
#define IMX51_IPU_COMMON_IPU_INT_CTRL_11_REG			0x00000064
#define IMX51_IPU_COMMON_IPU_INT_CTRL_12_REG			0x00000068
#define IMX51_IPU_COMMON_IPU_INT_CTRL_13_REG			0x0000006c
#define IMX51_IPU_COMMON_IPU_INT_CTRL_14_REG			0x00000070
#define IMX51_IPU_COMMON_IPU_INT_CTRL_15_REG			0x00000074
#define IMX51_IPU_COMMON_IPU_SDMA_EVENT_1_REG			0x00000078
#define IMX51_IPU_COMMON_IPU_SDMA_EVENT_2_REG			0x0000007c
#define IMX51_IPU_COMMON_IPU_SDMA_EVENT_3_REG			0x00000080
#define IMX51_IPU_COMMON_IPU_SDMA_EVENT_4_REG			0x00000084
#define IMX51_IPU_COMMON_IPU_SDMA_EVENT_7_REG			0x00000088
#define IMX51_IPU_COMMON_IPU_SDMA_EVENT_8_REG			0x0000008c
#define IMX51_IPU_COMMON_IPU_SDMA_EVENT_11_REG			0x00000090
#define IMX51_IPU_COMMON_IPU_SDMA_EVENT_12_REG			0x00000094
#define IMX51_IPU_COMMON_IPU_SDMA_EVENT_13_REG			0x00000098
#define IMX51_IPU_COMMON_IPU_SDMA_EVENT_14_REG			0x0000009c
#define IMX51_IPU_COMMON_IPU_SRM_PRI1_REG			0x000000a0
#define IMX51_IPU_COMMON_IPU_SRM_PRI2_REG			0x000000a4
# define IMX51_IPU_COMMON_IPU_SRM_PRI2_DP_SRM_PRI(n)		((n) & 7)
# define IMX51_IPU_COMMON_IPU_SRM_PRI2_DP_S_SRM_MODE(n)		(((n) & 3) << 3)
#define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW1_REG			0x000000a8
#define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW2_REG			0x000000ac
#define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW3_REG			0x000000b0
# define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW_PRPENC_ROT_SRC(n)	(((n) & 15) << 0)
# define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW_ALT_ISP_SRC(n)	(((n) & 15) << 4)
# define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW_PRPVF_ROT_SRC(n)	(((n) & 15) << 8)
# define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW_PP_SRC(n)		(((n) & 15) << 12)
# define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW_PP_ROT_SRC(n)	(((n) & 15) << 16)
# define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW_ISP_SRC(n)		(((n) & 15) << 20)
# define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW_PRP_SRC(n)		(((n) & 15) << 24)
# define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW_VDI_SRC_SEL(n)	(((n) & 3) << 28)
# define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW_ENC_IN_VALID		__BIT(30)
# define IMX51_IPU_COMMON_IPU_FS_PROC_FLOW_VF_IN_VALID		__BIT(31)
#define IMX51_IPU_COMMON_IPU_FS_DISP_FLOW1_REG			0x000000b4
#define IMX51_IPU_COMMON_IPU_FS_DISP_FLOW2_REG			0x000000b8
#define IMX51_IPU_COMMON_IPU_SKIP_REG				0x000000bc
#define IMX51_IPU_COMMON_IPU_DISP_ALT_CONF_REG			0x000000c0
#define IMX51_IPU_COMMON_IPU_DISP_GEN_REG			0x000000c4
# define IMX51_IPU_COMMON_IPU_DISP_GEN_MCU_MAX_BURST_STOP	__BIT(22)
# define IMX51_IPU_COMMON_IPU_DISP_GEN_MCU_T(n)			((n) << 18)
#define IMX51_IPU_COMMON_IPU_DISP_ALT1_REG			0x000000c8
#define IMX51_IPU_COMMON_IPU_DISP_ALT2_REG			0x000000cc
#define IMX51_IPU_COMMON_IPU_DISP_ALT3_REG			0x000000d0
#define IMX51_IPU_COMMON_IPU_DISP_ALT4_REG			0x000000d4
#define IMX51_IPU_COMMON_IPU_SNOOP_REG				0x000000d8
#define IMX51_IPU_COMMON_IPU_MEM_RST_REG			0x000000dc
# define IMX51_IPU_COMMON_IPU_MEM_RST_START			0x80000000
#define IMX51_IPU_COMMON_IPU_PM_REG				0x000000e0
#define IMX51_IPU_COMMON_IPU_GPR_REG				0x000000e4
#define IMX51_IPU_COMMON_IPU_CH_DB_MODE_SEL_0_REG		0x00000150
#define IMX51_IPU_COMMON_IPU_CH_DB_MODE_SEL_1_REG		0x00000154
#define IMX51_IPU_COMMON_IPU_ALT_CH_DB_MODE_SEL_0_REG		0x00000168
#define IMX51_IPU_COMMON_IPU_ALT_CH_DB_MODE_SEL_1_REG		0x0000016c
#define IMX51_IPU_COMMON_IPU_CH_TRB_MODE_SEL_0_REG		0x00000178
#define IMX51_IPU_COMMON_IPU_CH_TRB_MODE_SEL_1_REG		0x0000017c

#define IMX51_IPU_COMMON_IPU_INT_STAT_REG(n)			(0x00000200 + (4 * (n)))
#define IMX51_IPU_COMMON_IPU_INT_STAT_1_REG			0x00000200
#define IMX51_IPU_COMMON_IPU_INT_STAT_2_REG			0x00000204
#define IMX51_IPU_COMMON_IPU_INT_STAT_3_REG			0x00000208
#define IMX51_IPU_COMMON_IPU_INT_STAT_4_REG			0x0000020c
#define IMX51_IPU_COMMON_IPU_INT_STAT_5_REG			0x00000210
#define IMX51_IPU_COMMON_IPU_INT_STAT_6_REG			0x00000214
#define IMX51_IPU_COMMON_IPU_INT_STAT_7_REG			0x00000218
#define IMX51_IPU_COMMON_IPU_INT_STAT_8_REG			0x0000021c
#define IMX51_IPU_COMMON_IPU_INT_STAT_9_REG			0x00000220
#define IMX51_IPU_COMMON_IPU_INT_STAT_10_REG			0x00000224
#define IMX51_IPU_COMMON_IPU_INT_STAT_11_REG			0x00000228
#define IMX51_IPU_COMMON_IPU_INT_STAT_12_REG			0x0000022c
#define IMX51_IPU_COMMON_IPU_INT_STAT_13_REG			0x00000230
#define IMX51_IPU_COMMON_IPU_INT_STAT_14_REG			0x00000234
#define IMX51_IPU_COMMON_IPU_INT_STAT_15_REG			0x00000238
#define IMX51_IPU_COMMON_IPU_CUR_BUF_0_REG			0x0000023c
#define IMX51_IPU_COMMON_IPU_CUR_BUF_1_REG			0x00000240
#define IMX51_IPU_COMMON_IPU_ALT_CUR_BUF_0_REG			0x00000244
#define IMX51_IPU_COMMON_IPU_ALT_CUR_BUF_1_REG			0x00000248
#define IMX51_IPU_COMMON_IPU_SRM_STAT_REG			0x0000024c
#define IMX51_IPU_COMMON_IPU_PROC_TASKS_STAT_REG		0x00000250
#define IMX51_IPU_COMMON_IPU_DISP_TASKS_STAT_REG		0x00000254
#define IMX51_IPU_COMMON_IPU_TRIPLE_CUR_BUF_0_REG		0x00000258
#define IMX51_IPU_COMMON_IPU_TRIPLE_CUR_BUF_1_REG		0x0000025c
#define IMX51_IPU_COMMON_IPU_TRIPLE_CUR_BUF_2_REG		0x00000260
#define IMX51_IPU_COMMON_IPU_TRIPLE_CUR_BUF_3_REG		0x00000264
#define IMX51_IPU_COMMON_IPU_CH_BUF0_RDY0_REG			0x00000268
#define IMX51_IPU_COMMON_IPU_CH_BUF0_RDY1_REG			0x0000026c
#define IMX51_IPU_COMMON_IPU_CH_BUF1_RDY0_REG			0x00000270
#define IMX51_IPU_COMMON_IPU_CH_BUF1_RDY1_REG			0x00000274
#define IMX51_IPU_COMMON_IPU_ALT_CH_BUF0_RDY0_REG		0x00000278
#define IMX51_IPU_COMMON_IPU_ALT_CH_BUF0_RDY1_REG		0x0000027c
#define IMX51_IPU_COMMON_IPU_ALT_CH_BUF1_RDY0_REG		0x00000280
#define IMX51_IPU_COMMON_IPU_ALT_CH_BUF1_RDY1_REG		0x00000284
#define IMX51_IPU_COMMON_IPU_CH_BUF2_RDY0_REG			0x00000288
#define IMX51_IPU_COMMON_IPU_CH_BUF2_RDY1_REG			0x0000028c
#define IMX51_IPU_COMMON_IDMAC_CONF_REG				0x00008000
#define IMX51_IPU_COMMON_IDMAC_CH_EN_1_REG			0x00008004
#define IMX51_IPU_COMMON_IDMAC_CH_EN_2_REG			0x00008008
#define IMX51_IPU_COMMON_IDMAC_SEP_ALPHA_REG			0x0000800c
#define IMX51_IPU_COMMON_IDMAC_ALT_SEP_ALPHA_REG		0x00008010
#define IMX51_IPU_COMMON_IDMAC_CH_PRI_1_REG			0x00008014
#define IMX51_IPU_COMMON_IDMAC_CH_PRI_2_REG			0x00008018
#define IMX51_IPU_COMMON_IDMAC_WM_EN_1_REG			0x0000801c
#define IMX51_IPU_COMMON_IDMAC_WM_EN_2_REG			0x00008020
#define IMX51_IPU_COMMON_IDMAC_LOCK_EN_1_REG			0x00008024
#define IMX51_IPU_COMMON_IDMAC_LOCK_EN_2_REG			0x00008028
#define IMX51_IPU_COMMON_IDMAC_SUB_ADDR_0_REG			0x0000802c
#define IMX51_IPU_COMMON_IDMAC_SUB_ADDR_1_REG			0x00008030
#define IMX51_IPU_COMMON_IDMAC_SUB_ADDR_2_REG			0x00008034
#define IMX51_IPU_COMMON_IDMAC_SUB_ADDR_3_REG			0x00008038
#define IMX51_IPU_COMMON_IDMAC_SUB_ADDR_4_REG			0x0000803c
#define IMX51_IPU_COMMON_IDMAC_BNDM_EN_1_REG			0x00008040
#define IMX51_IPU_COMMON_IDMAC_BNDM_EN_2_REG			0x00008044
#define IMX51_IPU_COMMON_IDMAC_SC_CORD_REG			0x00008048
#define IMX51_IPU_COMMON_IDMAC_SC_CORD1_REG			0x0000804c
#define IMX51_IPU_COMMON_IDMAC_CH_BUSY_1_REG			0x00008100
#define IMX51_IPU_COMMON_IDMAC_CH_BUSY_2_REG			0x00008104
/* SRM registers are shadowed to 0xef040000 */
#define IMX51_IPU_COMMON_DP_DEBUG_CNT_REG			0x000180bc
#define IMX51_IPU_COMMON_DP_DEBUG_STAT_REG			0x000180c0
#define IMX51_IPU_COMMON_IC_CONF_REG				0x00020000
#define IMX51_IPU_COMMON_IC_PRP_ENC_RSC_REG			0x00020004
#define IMX51_IPU_COMMON_IC_PRP_VF_RSC_REG			0x00020008
#define IMX51_IPU_COMMON_IC_PP_RSC_REG				0x0002000c
#define IMX51_IPU_COMMON_IC_CMBP_1_REG				0x00020010
#define IMX51_IPU_COMMON_IC_CMBP_2_REG				0x00020014
#define IMX51_IPU_COMMON_IC_IDMAC_1_REG				0x00020018
#define IMX51_IPU_COMMON_IC_IDMAC_2_REG				0x0002001c
#define IMX51_IPU_COMMON_IC_IDMAC_3_REG				0x00020020
#define IMX51_IPU_COMMON_IC_IDMAC_4_REG				0x00020024
#define IMX51_IPU_COMMON_CSI0_SENS_CONF_REG			0x00030000
#define IMX51_IPU_COMMON_CSI0_SENS_FRM_SIZE_REG			0x00030004
#define IMX51_IPU_COMMON_CSI0_ACT_FRM_SIZE_REG			0x00030008
#define IMX51_IPU_COMMON_CSI0_OUT_FRM_CTRL_REG			0x0003000c
#define IMX51_IPU_COMMON_CSI0_TST_CTRL_REG			0x00030010
#define IMX51_IPU_COMMON_CSI0_CCIR_CODE_1_REG			0x00030014
#define IMX51_IPU_COMMON_CSI0_CCIR_CODE_2_REG			0x00030018
#define IMX51_IPU_COMMON_CSI0_CCIR_CODE_3_REG			0x0003001c
#define IMX51_IPU_COMMON_CSI0_DI_REG				0x00030020
#define IMX51_IPU_COMMON_CSI0_SKIP_REG				0x00030024
#define IMX51_IPU_COMMON_CSI0_CPD_CTRL_REG			0x00030028
#define IMX51_IPU_COMMON_CSI0_CPD_RC_0_REG			0x0003002c
#define IMX51_IPU_COMMON_CSI0_CPD_RC_1_REG			0x00030030
#define IMX51_IPU_COMMON_CSI0_CPD_RC_2_REG			0x00030034
#define IMX51_IPU_COMMON_CSI0_CPD_RC_3_REG			0x00030038
#define IMX51_IPU_COMMON_CSI0_CPD_RC_4_REG			0x0003003c
#define IMX51_IPU_COMMON_CSI0_CPD_RC_5_REG			0x00030040
#define IMX51_IPU_COMMON_CSI0_CPD_RC_6_REG			0x00030044
#define IMX51_IPU_COMMON_CSI0_CPD_RC_7_REG			0x00030048
#define IMX51_IPU_COMMON_CSI0_CPD_RS_0_REG			0x0003004c
#define IMX51_IPU_COMMON_CSI0_CPD_RS_1_REG			0x00030050
#define IMX51_IPU_COMMON_CSI0_CPD_RS_2_REG			0x00030054
#define IMX51_IPU_COMMON_CSI0_CPD_RS_3_REG			0x00030058
#define IMX51_IPU_COMMON_CSI0_CPD_GRC_0_REG			0x0003005c
#define IMX51_IPU_COMMON_CSI0_CPD_GRC_1_REG			0x00030060
#define IMX51_IPU_COMMON_CSI0_CPD_GRC_2_REG			0x00030064
#define IMX51_IPU_COMMON_CSI0_CPD_GRC_3_REG			0x00030068
#define IMX51_IPU_COMMON_CSI0_CPD_GRC_4_REG			0x0003006c
#define IMX51_IPU_COMMON_CSI0_CPD_GRC_5_REG			0x00030070
#define IMX51_IPU_COMMON_CSI0_CPD_GRC_6_REG			0x00030074
#define IMX51_IPU_COMMON_CSI0_CPD_GRC_7_REG			0x00030078
#define IMX51_IPU_COMMON_CSI0_CPD_GRS_0_REG			0x0003007c
#define IMX51_IPU_COMMON_CSI0_CPD_GRS_1_REG			0x00030080
#define IMX51_IPU_COMMON_CSI0_CPD_GRS_2_REG			0x00030084
#define IMX51_IPU_COMMON_CSI0_CPD_GRS_3_REG			0x00030088
#define IMX51_IPU_COMMON_CSI0_CPD_GBC_0_REG			0x0003008c
#define IMX51_IPU_COMMON_CSI0_CPD_GBC_1_REG			0x00030090
#define IMX51_IPU_COMMON_CSI0_CPD_GBC_2_REG			0x00030094
#define IMX51_IPU_COMMON_CSI0_CPD_GBC_3_REG			0x00030098
#define IMX51_IPU_COMMON_CSI0_CPD_GBC_4_REG			0x0003009c
#define IMX51_IPU_COMMON_CSI0_CPD_GBC_5_REG			0x000300a0
#define IMX51_IPU_COMMON_CSI0_CPD_GBC_6_REG			0x000300a4
#define IMX51_IPU_COMMON_CSI0_CPD_GBC_7_REG			0x000300a8
#define IMX51_IPU_COMMON_CSI0_CPD_GBS_0_REG			0x000300ac
#define IMX51_IPU_COMMON_CSI0_CPD_GBS_1_REG			0x000300b0
#define IMX51_IPU_COMMON_CSI0_CPD_GBS_2_REG			0x000300b4
#define IMX51_IPU_COMMON_CSI0_CPD_GBS_3_REG			0x000300b8
#define IMX51_IPU_COMMON_CSI0_CPD_BC_0_REG			0x000300bc
#define IMX51_IPU_COMMON_CSI0_CPD_BC_1_REG			0x000300c0
#define IMX51_IPU_COMMON_CSI0_CPD_BC_2_REG			0x000300c4
#define IMX51_IPU_COMMON_CSI0_CPD_BC_3_REG			0x000300c8
#define IMX51_IPU_COMMON_CSI0_CPD_BC_4_REG			0x000300cc
#define IMX51_IPU_COMMON_CSI0_CPD_BC_5_REG			0x000300d0
#define IMX51_IPU_COMMON_CSI0_CPD_BC_6_REG			0x000300d4
#define IMX51_IPU_COMMON_CSI0_CPD_BC_7_REG			0x000300d8
#define IMX51_IPU_COMMON_CSI0_CPD_BS_0_REG			0x000300dc
#define IMX51_IPU_COMMON_CSI0_CPD_BS_1_REG			0x000300e0
#define IMX51_IPU_COMMON_CSI0_CPD_BS_2_REG			0x000300e4
#define IMX51_IPU_COMMON_CSI0_CPD_BS_3_REG			0x000300e8
#define IMX51_IPU_COMMON_CSI0_CPD_OFFSET1_REG			0x000300ec
#define IMX51_IPU_COMMON_CSI0_CPD_OFFSET2_REG			0x000300f0
#define IMX51_IPU_COMMON_CSI1_SENS_CONF_REG			0x00038000
#define IMX51_IPU_COMMON_CSI1_SENS_FRM_SIZE_REG			0x00038004
#define IMX51_IPU_COMMON_CSI1_ACT_FRM_SIZE_REG			0x00038008
#define IMX51_IPU_COMMON_CSI1_OUT_FRM_CTRL_REG			0x0003800c
#define IMX51_IPU_COMMON_CSI1_TST_CTRL_REG			0x00038010
#define IMX51_IPU_COMMON_CSI1_CCIR_CODE_1_REG			0x00038014
#define IMX51_IPU_COMMON_CSI1_CCIR_CODE_2_REG			0x00038018
#define IMX51_IPU_COMMON_CSI1_CCIR_CODE_3_REG			0x0003801c
#define IMX51_IPU_COMMON_CSI1_DI_REG				0x00038020
#define IMX51_IPU_COMMON_CSI1_SKIP_REG				0x00038024
#define IMX51_IPU_COMMON_CSI1_CPD_CTRL_REG			0x00038028
#define IMX51_IPU_COMMON_CSI1_CPD_RC_0_REG			0x0003802c
#define IMX51_IPU_COMMON_CSI1_CPD_RC_1_REG			0x00038030
#define IMX51_IPU_COMMON_CSI1_CPD_RC_2_REG			0x00038034
#define IMX51_IPU_COMMON_CSI1_CPD_RC_3_REG			0x00038038
#define IMX51_IPU_COMMON_CSI1_CPD_RC_4_REG			0x0003803c
#define IMX51_IPU_COMMON_CSI1_CPD_RC_5_REG			0x00038040
#define IMX51_IPU_COMMON_CSI1_CPD_RC_6_REG			0x00038044
#define IMX51_IPU_COMMON_CSI1_CPD_RC_7_REG			0x00038048
#define IMX51_IPU_COMMON_CSI1_CPD_RS_0_REG			0x0003804c
#define IMX51_IPU_COMMON_CSI1_CPD_RS_1_REG			0x00038050
#define IMX51_IPU_COMMON_CSI1_CPD_RS_2_REG			0x00038054
#define IMX51_IPU_COMMON_CSI1_CPD_RS_3_REG			0x00038058
#define IMX51_IPU_COMMON_CSI1_CPD_GRC_0_REG			0x0003805c
#define IMX51_IPU_COMMON_CSI1_CPD_GRC_1_REG			0x00038060
#define IMX51_IPU_COMMON_CSI1_CPD_GRC_2_REG			0x00038064
#define IMX51_IPU_COMMON_CSI1_CPD_GRC_3_REG			0x00038068
#define IMX51_IPU_COMMON_CSI1_CPD_GRC_4_REG			0x0003806c
#define IMX51_IPU_COMMON_CSI1_CPD_GRC_5_REG			0x00038070
#define IMX51_IPU_COMMON_CSI1_CPD_GRC_6_REG			0x00038074
#define IMX51_IPU_COMMON_CSI1_CPD_GRC_7_REG			0x00038078
#define IMX51_IPU_COMMON_CSI1_CPD_GRS_0_REG			0x0003807c
#define IMX51_IPU_COMMON_CSI1_CPD_GRS_1_REG			0x00038080
#define IMX51_IPU_COMMON_CSI1_CPD_GRS_2_REG			0x00038084
#define IMX51_IPU_COMMON_CSI1_CPD_GRS_3_REG			0x00038088
#define IMX51_IPU_COMMON_CSI1_CPD_GBC_0_REG			0x0003808c
#define IMX51_IPU_COMMON_CSI1_CPD_GBC_1_REG			0x00038090
#define IMX51_IPU_COMMON_CSI1_CPD_GBC_2_REG			0x00038094
#define IMX51_IPU_COMMON_CSI1_CPD_GBC_3_REG			0x00038098
#define IMX51_IPU_COMMON_CSI1_CPD_GBC_4_REG			0x0003809c
#define IMX51_IPU_COMMON_CSI1_CPD_GBC_5_REG			0x000380a0
#define IMX51_IPU_COMMON_CSI1_CPD_GBC_6_REG			0x000380a4
#define IMX51_IPU_COMMON_CSI1_CPD_GBC_7_REG			0x000380a8
#define IMX51_IPU_COMMON_CSI1_CPD_GBS_0_REG			0x000380ac
#define IMX51_IPU_COMMON_CSI1_CPD_GBS_1_REG			0x000380b0
#define IMX51_IPU_COMMON_CSI1_CPD_GBS_2_REG			0x000380b4
#define IMX51_IPU_COMMON_CSI1_CPD_GBS_3_REG			0x000380b8
#define IMX51_IPU_COMMON_CSI1_CPD_BC_0_REG			0x000380bc
#define IMX51_IPU_COMMON_CSI1_CPD_BC_1_REG			0x000380c0
#define IMX51_IPU_COMMON_CSI1_CPD_BC_2_REG			0x000380c4
#define IMX51_IPU_COMMON_CSI1_CPD_BC_3_REG			0x000380c8
#define IMX51_IPU_COMMON_CSI1_CPD_BC_4_REG			0x000380cc
#define IMX51_IPU_COMMON_CSI1_CPD_BC_5_REG			0x000380d0
#define IMX51_IPU_COMMON_CSI1_CPD_BC_6_REG			0x000380d4
#define IMX51_IPU_COMMON_CSI1_CPD_BC_7_REG			0x000380d8
#define IMX51_IPU_COMMON_CSI1_CPD_BS_0_REG			0x000380dc
#define IMX51_IPU_COMMON_CSI1_CPD_BS_1_REG			0x000380e0
#define IMX51_IPU_COMMON_CSI1_CPD_BS_2_REG			0x000380e4
#define IMX51_IPU_COMMON_CSI1_CPD_BS_3_REG			0x000380e8
#define IMX51_IPU_COMMON_CSI1_CPD_OFFSET1_REG			0x000380ec
#define IMX51_IPU_COMMON_CSI1_CPD_OFFSET2_REG			0x000380f0
#define IMX51_IPU_COMMON_DI0_GENERAL_REG			0x00040000
#define IMX51_IPU_COMMON_DI0_BS_CLKGEN0_REG			0x00040004
#define IMX51_IPU_COMMON_DI0_BS_CLKGEN1_REG			0x00040008
#define IMX51_IPU_COMMON_DI0_SW_GEN0_1_REG			0x0004000c
#define IMX51_IPU_COMMON_DI0_SW_GEN0_2_REG			0x00040010
#define IMX51_IPU_COMMON_DI0_SW_GEN0_3_REG			0x00040014
#define IMX51_IPU_COMMON_DI0_SW_GEN0_4_REG			0x00040018
#define IMX51_IPU_COMMON_DI0_SW_GEN0_5_REG			0x0004001c
#define IMX51_IPU_COMMON_DI0_SW_GEN0_6_REG			0x00040020
#define IMX51_IPU_COMMON_DI0_SW_GEN0_7_REG			0x00040024
#define IMX51_IPU_COMMON_DI0_SW_GEN0_8_REG			0x00040028
#define IMX51_IPU_COMMON_DI0_SW_GEN0_9_REG			0x0004002c
#define IMX51_IPU_COMMON_DI0_SW_GEN1_1_REG			0x00040030
#define IMX51_IPU_COMMON_DI0_SW_GEN1_2_REG			0x00040034
#define IMX51_IPU_COMMON_DI0_SW_GEN1_3_REG			0x00040038
#define IMX51_IPU_COMMON_DI0_SW_GEN1_4_REG			0x0004003c
#define IMX51_IPU_COMMON_DI0_SW_GEN1_5_REG			0x00040040
#define IMX51_IPU_COMMON_DI0_SW_GEN1_6_REG			0x00040044
#define IMX51_IPU_COMMON_DI0_SW_GEN1_7_REG			0x00040048
#define IMX51_IPU_COMMON_DI0_SW_GEN1_8_REG			0x0004004c
#define IMX51_IPU_COMMON_DI0_SW_GEN1_9_REG			0x00040050
#define IMX51_IPU_COMMON_DI0_SYNC_AS_GEN_REG			0x00040054
#define IMX51_IPU_COMMON_DI0_DW_GEN_0_REG			0x00040058
#define IMX51_IPU_COMMON_DI0_DW_GEN_1_REG			0x0004005c
#define IMX51_IPU_COMMON_DI0_DW_GEN_2_REG			0x00040060
#define IMX51_IPU_COMMON_DI0_DW_GEN_3_REG			0x00040064
#define IMX51_IPU_COMMON_DI0_DW_GEN_4_REG			0x00040068
#define IMX51_IPU_COMMON_DI0_DW_GEN_5_REG			0x0004006c
#define IMX51_IPU_COMMON_DI0_DW_GEN_6_REG			0x00040070
#define IMX51_IPU_COMMON_DI0_DW_GEN_7_REG			0x00040074
#define IMX51_IPU_COMMON_DI0_DW_GEN_8_REG			0x00040078
#define IMX51_IPU_COMMON_DI0_DW_GEN_9_REG			0x0004007c
#define IMX51_IPU_COMMON_DI0_DW_GEN_10_REG			0x00040080
#define IMX51_IPU_COMMON_DI0_DW_GEN_11_REG			0x00040084
#define IMX51_IPU_COMMON_DI0_DW_SET0_0_REG			0x00040088
#define IMX51_IPU_COMMON_DI0_DW_SET0_1_REG			0x0004008c
#define IMX51_IPU_COMMON_DI0_DW_SET0_2_REG			0x00040090
#define IMX51_IPU_COMMON_DI0_DW_SET0_3_REG			0x00040094
#define IMX51_IPU_COMMON_DI0_DW_SET0_4_REG			0x00040098
#define IMX51_IPU_COMMON_DI0_DW_SET0_5_REG			0x0004009c
#define IMX51_IPU_COMMON_DI0_DW_SET0_6_REG			0x000400a0
#define IMX51_IPU_COMMON_DI0_DW_SET0_7_REG			0x000400a4
#define IMX51_IPU_COMMON_DI0_DW_SET0_8_REG			0x000400a8
#define IMX51_IPU_COMMON_DI0_DW_SET0_9_REG			0x000400ac
#define IMX51_IPU_COMMON_DI0_DW_SET0_10_REG			0x000400b0
#define IMX51_IPU_COMMON_DI0_DW_SET0_11_REG			0x000400b4
#define IMX51_IPU_COMMON_DI0_DW_SET1_0_REG			0x000400b8
#define IMX51_IPU_COMMON_DI0_DW_SET1_1_REG			0x000400bc
#define IMX51_IPU_COMMON_DI0_DW_SET1_2_REG			0x000400c0
#define IMX51_IPU_COMMON_DI0_DW_SET1_3_REG			0x000400c4
#define IMX51_IPU_COMMON_DI0_DW_SET1_4_REG			0x000400c8
#define IMX51_IPU_COMMON_DI0_DW_SET1_5_REG			0x000400cc
#define IMX51_IPU_COMMON_DI0_DW_SET1_6_REG			0x000400d0
#define IMX51_IPU_COMMON_DI0_DW_SET1_7_REG			0x000400d4
#define IMX51_IPU_COMMON_DI0_DW_SET1_8_REG			0x000400d8
#define IMX51_IPU_COMMON_DI0_DW_SET1_9_REG			0x000400dc
#define IMX51_IPU_COMMON_DI0_DW_SET1_10_REG			0x000400e0
#define IMX51_IPU_COMMON_DI0_DW_SET1_11_REG			0x000400e4
#define IMX51_IPU_COMMON_DI0_DW_SET2_0_REG			0x000400e8
#define IMX51_IPU_COMMON_DI0_DW_SET2_1_REG			0x000400ec
#define IMX51_IPU_COMMON_DI0_DW_SET2_2_REG			0x000400f0
#define IMX51_IPU_COMMON_DI0_DW_SET2_3_REG			0x000400f4
#define IMX51_IPU_COMMON_DI0_DW_SET2_4_REG			0x000400f8
#define IMX51_IPU_COMMON_DI0_DW_SET2_5_REG			0x000400fc
#define IMX51_IPU_COMMON_DI0_DW_SET2_6_REG			0x00040100
#define IMX51_IPU_COMMON_DI0_DW_SET2_7_REG			0x00040104
#define IMX51_IPU_COMMON_DI0_DW_SET2_8_REG			0x00040108
#define IMX51_IPU_COMMON_DI0_DW_SET2_9_REG			0x0004010c
#define IMX51_IPU_COMMON_DI0_DW_SET2_10_REG			0x00040110
#define IMX51_IPU_COMMON_DI0_DW_SET2_11_REG			0x00040114
#define IMX51_IPU_COMMON_DI0_DW_SET3_0_REG			0x00040118
#define IMX51_IPU_COMMON_DI0_DW_SET3_1_REG			0x0004011c
#define IMX51_IPU_COMMON_DI0_DW_SET3_2_REG			0x00040120
#define IMX51_IPU_COMMON_DI0_DW_SET3_3_REG			0x00040124
#define IMX51_IPU_COMMON_DI0_DW_SET3_4_REG			0x00040128
#define IMX51_IPU_COMMON_DI0_DW_SET3_5_REG			0x0004012c
#define IMX51_IPU_COMMON_DI0_DW_SET3_6_REG			0x00040130
#define IMX51_IPU_COMMON_DI0_DW_SET3_7_REG			0x00040134
#define IMX51_IPU_COMMON_DI0_DW_SET3_8_REG			0x00040138
#define IMX51_IPU_COMMON_DI0_DW_SET3_9_REG			0x0004013c
#define IMX51_IPU_COMMON_DI0_DW_SET3_10_REG			0x00040140
#define IMX51_IPU_COMMON_DI0_DW_SET3_11_REG			0x00040144
#define IMX51_IPU_COMMON_DI0_STP_REP_1_REG			0x00040148
#define IMX51_IPU_COMMON_DI0_STP_REP_2_REG			0x0004014c
#define IMX51_IPU_COMMON_DI0_STP_REP_3_REG			0x00040150
#define IMX51_IPU_COMMON_DI0_STP_REP_4_REG			0x00040154
#define IMX51_IPU_COMMON_DI0_STP_REP_9_REG			0x00040158
#define IMX51_IPU_COMMON_DI0_SER_CONF_REG			0x0004015c
#define IMX51_IPU_COMMON_DI0_SSC_REG				0x00040160
#define IMX51_IPU_COMMON_DI0_POL_REG				0x00040164
#define IMX51_IPU_COMMON_DI0_AW0_REG				0x00040168
#define IMX51_IPU_COMMON_DI0_AW1_REG				0x0004016c
#define IMX51_IPU_COMMON_DI0_SCR_CONF_REG			0x00040170
#define IMX51_IPU_COMMON_DI0_STAT_REG				0x00040174
#define IMX51_IPU_COMMON_DI1_GENERAL_REG			0x00048000
#define IMX51_IPU_COMMON_DI1_BS_CLKGEN0_REG			0x00048004
#define IMX51_IPU_COMMON_DI1_BS_CLKGEN1_REG			0x00048008
#define IMX51_IPU_COMMON_DI1_SW_GEN0_1_REG			0x0004800c
#define IMX51_IPU_COMMON_DI1_SW_GEN0_2_REG			0x00048010
#define IMX51_IPU_COMMON_DI1_SW_GEN0_3_REG			0x00048014
#define IMX51_IPU_COMMON_DI1_SW_GEN0_4_REG			0x00048018
#define IMX51_IPU_COMMON_DI1_SW_GEN0_5_REG			0x0004801c
#define IMX51_IPU_COMMON_DI1_SW_GEN0_6_REG			0x00048020
#define IMX51_IPU_COMMON_DI1_SW_GEN0_7_REG			0x00048024
#define IMX51_IPU_COMMON_DI1_SW_GEN0_8_REG			0x00048028
#define IMX51_IPU_COMMON_DI1_SW_GEN0_9_REG			0x0004802c
#define IMX51_IPU_COMMON_DI1_SW_GEN1_1_REG			0x00048030
#define IMX51_IPU_COMMON_DI1_SW_GEN1_2_REG			0x00048034
#define IMX51_IPU_COMMON_DI1_SW_GEN1_3_REG			0x00048038
#define IMX51_IPU_COMMON_DI1_SW_GEN1_4_REG			0x0004803c
#define IMX51_IPU_COMMON_DI1_SW_GEN1_5_REG			0x00048040
#define IMX51_IPU_COMMON_DI1_SW_GEN1_6_REG			0x00048044
#define IMX51_IPU_COMMON_DI1_SW_GEN1_7_REG			0x00048048
#define IMX51_IPU_COMMON_DI1_SW_GEN1_8_REG			0x0004804c
#define IMX51_IPU_COMMON_DI1_SW_GEN1_9_REG			0x00048050
#define IMX51_IPU_COMMON_DI1_SYNC_AS_GEN_REG			0x00048054
#define IMX51_IPU_COMMON_DI1_DW_GEN_0_REG			0x00048058
#define IMX51_IPU_COMMON_DI1_DW_GEN_1_REG			0x0004805c
#define IMX51_IPU_COMMON_DI1_DW_GEN_2_REG			0x00048060
#define IMX51_IPU_COMMON_DI1_DW_GEN_3_REG			0x00048064
#define IMX51_IPU_COMMON_DI1_DW_GEN_4_REG			0x00048068
#define IMX51_IPU_COMMON_DI1_DW_GEN_5_REG			0x0004806c
#define IMX51_IPU_COMMON_DI1_DW_GEN_6_REG			0x00048070
#define IMX51_IPU_COMMON_DI1_DW_GEN_7_REG			0x00048074
#define IMX51_IPU_COMMON_DI1_DW_GEN_8_REG			0x00048078
#define IMX51_IPU_COMMON_DI1_DW_GEN_9_REG			0x0004807c
#define IMX51_IPU_COMMON_DI1_DW_GEN_10_REG			0x00048080
#define IMX51_IPU_COMMON_DI1_DW_GEN_11_REG			0x00048084
#define IMX51_IPU_COMMON_DI1_DW_SET0_0_REG			0x00048088
#define IMX51_IPU_COMMON_DI1_DW_SET0_1_REG			0x0004808c
#define IMX51_IPU_COMMON_DI1_DW_SET0_2_REG			0x00048090
#define IMX51_IPU_COMMON_DI1_DW_SET0_3_REG			0x00048094
#define IMX51_IPU_COMMON_DI1_DW_SET0_4_REG			0x00048098
#define IMX51_IPU_COMMON_DI1_DW_SET0_5_REG			0x0004809c
#define IMX51_IPU_COMMON_DI1_DW_SET0_6_REG			0x000480a0
#define IMX51_IPU_COMMON_DI1_DW_SET0_7_REG			0x000480a4
#define IMX51_IPU_COMMON_DI1_DW_SET0_8_REG			0x000480a8
#define IMX51_IPU_COMMON_DI1_DW_SET0_9_REG			0x000480ac
#define IMX51_IPU_COMMON_DI1_DW_SET0_10_REG			0x000480b0
#define IMX51_IPU_COMMON_DI1_DW_SET0_11_REG			0x000480b4
#define IMX51_IPU_COMMON_DI1_DW_SET1_0_REG			0x000480b8
#define IMX51_IPU_COMMON_DI1_DW_SET1_1_REG			0x000480bc
#define IMX51_IPU_COMMON_DI1_DW_SET1_2_REG			0x000480c0
#define IMX51_IPU_COMMON_DI1_DW_SET1_3_REG			0x000480c4
#define IMX51_IPU_COMMON_DI1_DW_SET1_4_REG			0x000480c8
#define IMX51_IPU_COMMON_DI1_DW_SET1_5_REG			0x000480cc
#define IMX51_IPU_COMMON_DI1_DW_SET1_6_REG			0x000480d0
#define IMX51_IPU_COMMON_DI1_DW_SET1_7_REG			0x000480d4
#define IMX51_IPU_COMMON_DI1_DW_SET1_8_REG			0x000480d8
#define IMX51_IPU_COMMON_DI1_DW_SET1_9_REG			0x000480dc
#define IMX51_IPU_COMMON_DI1_DW_SET1_10_REG			0x000480e0
#define IMX51_IPU_COMMON_DI1_DW_SET1_11_REG			0x000480e4
#define IMX51_IPU_COMMON_DI1_DW_SET2_0_REG			0x000480e8
#define IMX51_IPU_COMMON_DI1_DW_SET2_1_REG			0x000480ec
#define IMX51_IPU_COMMON_DI1_DW_SET2_2_REG			0x000480f0
#define IMX51_IPU_COMMON_DI1_DW_SET2_3_REG			0x000480f4
#define IMX51_IPU_COMMON_DI1_DW_SET2_4_REG			0x000480f8
#define IMX51_IPU_COMMON_DI1_DW_SET2_5_REG			0x000480fc
#define IMX51_IPU_COMMON_DI1_DW_SET2_6_REG			0x00048100
#define IMX51_IPU_COMMON_DI1_DW_SET2_7_REG			0x00048104
#define IMX51_IPU_COMMON_DI1_DW_SET2_8_REG			0x00048108
#define IMX51_IPU_COMMON_DI1_DW_SET2_9_REG			0x0004810c
#define IMX51_IPU_COMMON_DI1_DW_SET2_10_REG			0x00048110
#define IMX51_IPU_COMMON_DI1_DW_SET2_11_REG			0x00048114
#define IMX51_IPU_COMMON_DI1_DW_SET3_0_REG			0x00048118
#define IMX51_IPU_COMMON_DI1_DW_SET3_1_REG			0x0004811c
#define IMX51_IPU_COMMON_DI1_DW_SET3_2_REG			0x00048120
#define IMX51_IPU_COMMON_DI1_DW_SET3_3_REG			0x00048124
#define IMX51_IPU_COMMON_DI1_DW_SET3_4_REG			0x00048128
#define IMX51_IPU_COMMON_DI1_DW_SET3_5_REG			0x0004812c
#define IMX51_IPU_COMMON_DI1_DW_SET3_6_REG			0x00048130
#define IMX51_IPU_COMMON_DI1_DW_SET3_7_REG			0x00048134
#define IMX51_IPU_COMMON_DI1_DW_SET3_8_REG			0x00048138
#define IMX51_IPU_COMMON_DI1_DW_SET3_9_REG			0x0004813c
#define IMX51_IPU_COMMON_DI1_DW_SET3_10_REG			0x00048140
#define IMX51_IPU_COMMON_DI1_DW_SET3_11_REG			0x00048144
#define IMX51_IPU_COMMON_DI1_STP_REP_1_REG			0x00048148
#define IMX51_IPU_COMMON_DI1_STP_REP_2_REG			0x0004814c
#define IMX51_IPU_COMMON_DI1_STP_REP_3_REG			0x00048150
#define IMX51_IPU_COMMON_DI1_STP_REP_4_REG			0x00048154
#define IMX51_IPU_COMMON_DI1_STP_REP_9_REG			0x00048158
#define IMX51_IPU_COMMON_DI1_SER_CONF_REG			0x0004815c
#define IMX51_IPU_COMMON_DI1_SSC_REG				0x00048160
#define IMX51_IPU_COMMON_DI1_POL_REG				0x00048164
#define IMX51_IPU_COMMON_DI1_AW0_REG				0x00048168
#define IMX51_IPU_COMMON_DI1_AW1_REG				0x0004816c
#define IMX51_IPU_COMMON_DI1_SCR_CONF_REG			0x00048170
#define IMX51_IPU_COMMON_DI1_STAT_REG				0x00048174
#define IMX51_IPU_COMMON_SMFC_MAP_REG				0x00050000
#define IMX51_IPU_COMMON_SMFC_WMC_REG				0x00050004
#define IMX51_IPU_COMMON_SMFC_BS_REG				0x00050008
#define IMX51_IPU_COMMON_DC_READ_CH_CONF_REG			0x00058000
#define IMX51_IPU_COMMON_DC_READ_CH_ADDR_REG			0x00058004
#define IMX51_IPU_COMMON_DC_RL0_CH_0_REG			0x00058008
#define IMX51_IPU_COMMON_DC_RL1_CH_0_REG			0x0005800c
#define IMX51_IPU_COMMON_DC_RL2_CH_0_REG			0x00058010
#define IMX51_IPU_COMMON_DC_RL3_CH_0_REG			0x00058014
#define IMX51_IPU_COMMON_DC_RL4_CH_0_REG			0x00058018
#define IMX51_IPU_COMMON_DC_WR_CH_CONF_1_REG			0x0005801c
#define IMX51_IPU_COMMON_DC_WR_CH_ADDR_1_REG			0x00058020
#define IMX51_IPU_COMMON_DC_RL0_CH_1_REG			0x00058024
#define IMX51_IPU_COMMON_DC_RL1_CH_1_REG			0x00058028
#define IMX51_IPU_COMMON_DC_RL2_CH_1_REG			0x0005802c
#define IMX51_IPU_COMMON_DC_RL3_CH_1_REG			0x00058030
#define IMX51_IPU_COMMON_DC_RL4_CH_1_REG			0x00058034
#define IMX51_IPU_COMMON_DC_WR_CH_CONF_2_REG			0x00058038
#define IMX51_IPU_COMMON_DC_WR_CH_ADDR_2_REG			0x0005803c
#define IMX51_IPU_COMMON_DC_RL0_CH_2_REG			0x00058040
#define IMX51_IPU_COMMON_DC_RL1_CH_2_REG			0x00058044
#define IMX51_IPU_COMMON_DC_RL2_CH_2_REG			0x00058048
#define IMX51_IPU_COMMON_DC_RL3_CH_2_REG			0x0005804c
#define IMX51_IPU_COMMON_DC_RL4_CH_2_REG			0x00058050
#define IMX51_IPU_COMMON_DC_CMD_CH_CONF_3_REG			0x00058054
#define IMX51_IPU_COMMON_DC_CMD_CH_CONF_4_REG			0x00058058
#define IMX51_IPU_COMMON_DC_WR_CH_CONF_5_REG			0x0005805c
#define IMX51_IPU_COMMON_DC_WR_CH_ADDR_5_REG			0x00058060
#define IMX51_IPU_COMMON_DC_RL0_CH_5_REG			0x00058064
#define IMX51_IPU_COMMON_DC_RL1_CH_5_REG			0x00058068
#define IMX51_IPU_COMMON_DC_RL2_CH_5_REG			0x0005806c
#define IMX51_IPU_COMMON_DC_RL3_CH_5_REG			0x00058070
#define IMX51_IPU_COMMON_DC_RL4_CH_5_REG			0x00058074
#define IMX51_IPU_COMMON_DC_WR_CH_CONF_6_REG			0x00058078
#define IMX51_IPU_COMMON_DC_WR_CH_ADDR_6_REG			0x0005807c
#define IMX51_IPU_COMMON_DC_RL0_CH_6_REG			0x00058080
#define IMX51_IPU_COMMON_DC_RL1_CH_6_REG			0x00058084
#define IMX51_IPU_COMMON_DC_RL2_CH_6_REG			0x00058088
#define IMX51_IPU_COMMON_DC_RL3_CH_6_REG			0x0005808c
#define IMX51_IPU_COMMON_DC_RL4_CH_6_REG			0x00058090
#define IMX51_IPU_COMMON_DC_WR_CH_CONF1_8_REG			0x00058094
#define IMX51_IPU_COMMON_DC_WR_CH_CONF2_8_REG			0x00058098
#define IMX51_IPU_COMMON_DC_RL1_CH_8_REG			0x0005809c
#define IMX51_IPU_COMMON_DC_RL2_CH_8_REG			0x000580a0
#define IMX51_IPU_COMMON_DC_RL3_CH_8_REG			0x000580a4
#define IMX51_IPU_COMMON_DC_RL4_CH_8_REG			0x000580a8
#define IMX51_IPU_COMMON_DC_RL5_CH_8_REG			0x000580ac
#define IMX51_IPU_COMMON_DC_RL6_CH_8_REG			0x000580b0
#define IMX51_IPU_COMMON_DC_WR_CH_CONF1_9_REG			0x000580b4
#define IMX51_IPU_COMMON_DC_WR_CH_CONF2_9_REG			0x000580b8
#define IMX51_IPU_COMMON_DC_RL1_CH_9_REG			0x000580bc
#define IMX51_IPU_COMMON_DC_RL2_CH_9_REG			0x000580c0
#define IMX51_IPU_COMMON_DC_RL3_CH_9_REG			0x000580c4
#define IMX51_IPU_COMMON_DC_RL4_CH_9_REG			0x000580c8
#define IMX51_IPU_COMMON_DC_RL5_CH_9_REG			0x000580cc
#define IMX51_IPU_COMMON_DC_RL6_CH_9_REG			0x000580d0
#define IMX51_IPU_COMMON_DC_GEN_REG				0x000580d4
#define IMX51_IPU_COMMON_DC_DISP_CONF1_0_REG			0x000580d8
#define IMX51_IPU_COMMON_DC_DISP_CONF1_1_REG			0x000580dc
#define IMX51_IPU_COMMON_DC_DISP_CONF1_2_REG			0x000580e0
#define IMX51_IPU_COMMON_DC_DISP_CONF1_3_REG			0x000580e4
#define IMX51_IPU_COMMON_DC_DISP_CONF2_0_REG			0x000580e8
#define IMX51_IPU_COMMON_DC_DISP_CONF2_1_REG			0x000580ec
#define IMX51_IPU_COMMON_DC_DISP_CONF2_2_REG			0x000580f0
#define IMX51_IPU_COMMON_DC_DISP_CONF2_3_REG			0x000580f4
#define IMX51_IPU_COMMON_DC_DI0_CONF_1_REG			0x000580f8
#define IMX51_IPU_COMMON_DC_DI0_CONF_2_REG			0x000580fc
#define IMX51_IPU_COMMON_DC_DI1_CONF_1_REG			0x00058100
#define IMX51_IPU_COMMON_DC_DI1_CONF_2_REG			0x00058104
#define IMX51_IPU_COMMON_DC_MAP_CONF_0_REG			0x00058108
#define IMX51_IPU_COMMON_DC_MAP_CONF_1_REG			0x0005810c
#define IMX51_IPU_COMMON_DC_MAP_CONF_2_REG			0x00058110
#define IMX51_IPU_COMMON_DC_MAP_CONF_3_REG			0x00058114
#define IMX51_IPU_COMMON_DC_MAP_CONF_4_REG			0x00058118
#define IMX51_IPU_COMMON_DC_MAP_CONF_5_REG			0x0005811c
#define IMX51_IPU_COMMON_DC_MAP_CONF_6_REG			0x00058120
#define IMX51_IPU_COMMON_DC_MAP_CONF_7_REG			0x00058124
#define IMX51_IPU_COMMON_DC_MAP_CONF_8_REG			0x00058128
#define IMX51_IPU_COMMON_DC_MAP_CONF_9_REG			0x0005812c
#define IMX51_IPU_COMMON_DC_MAP_CONF_10_REG			0x00058130
#define IMX51_IPU_COMMON_DC_MAP_CONF_11_REG			0x00058134
#define IMX51_IPU_COMMON_DC_MAP_CONF_12_REG			0x00058138
#define IMX51_IPU_COMMON_DC_MAP_CONF_13_REG			0x0005813c
#define IMX51_IPU_COMMON_DC_MAP_CONF_14_REG			0x00058140
#define IMX51_IPU_COMMON_DC_MAP_CONF_15_REG			0x00058144
#define IMX51_IPU_COMMON_DC_MAP_CONF_16_REG			0x00058148
#define IMX51_IPU_COMMON_DC_MAP_CONF_17_REG			0x0005814c
#define IMX51_IPU_COMMON_DC_MAP_CONF_18_REG			0x00058150
#define IMX51_IPU_COMMON_DC_MAP_CONF_19_REG			0x00058154
#define IMX51_IPU_COMMON_DC_MAP_CONF_20_REG			0x00058158
#define IMX51_IPU_COMMON_DC_MAP_CONF_21_REG			0x0005815c
#define IMX51_IPU_COMMON_DC_MAP_CONF_22_REG			0x00058160
#define IMX51_IPU_COMMON_DC_MAP_CONF_23_REG			0x00058164
#define IMX51_IPU_COMMON_DC_MAP_CONF_24_REG			0x00058168
#define IMX51_IPU_COMMON_DC_MAP_CONF_25_REG			0x0005816c
#define IMX51_IPU_COMMON_DC_MAP_CONF_26_REG			0x00058170
#define IMX51_IPU_COMMON_DC_UGDE0_0_REG				0x00058174
#define IMX51_IPU_COMMON_DC_UGDE0_1_REG				0x00058178
#define IMX51_IPU_COMMON_DC_UGDE0_2_REG				0x0005817c
#define IMX51_IPU_COMMON_DC_UGDE0_3_REG				0x00058180
#define IMX51_IPU_COMMON_DC_UGDE1_0_REG				0x00058184
#define IMX51_IPU_COMMON_DC_UGDE1_1_REG				0x00058188
#define IMX51_IPU_COMMON_DC_UGDE1_2_REG				0x0005818c
#define IMX51_IPU_COMMON_DC_UGDE1_3_REG				0x00058190
#define IMX51_IPU_COMMON_DC_UGDE2_0_REG				0x00058194
#define IMX51_IPU_COMMON_DC_UGDE2_1_REG				0x00058198
#define IMX51_IPU_COMMON_DC_UGDE2_2_REG				0x0005819c
#define IMX51_IPU_COMMON_DC_UGDE2_3_REG				0x000581a0
#define IMX51_IPU_COMMON_DC_UGDE3_0_REG				0x000581a4
#define IMX51_IPU_COMMON_DC_UGDE3_1_REG				0x000581a8
#define IMX51_IPU_COMMON_DC_UGDE3_2_REG				0x000581ac
#define IMX51_IPU_COMMON_DC_UGDE3_3_REG				0x000581b0
#define IMX51_IPU_COMMON_DC_LLA0_REG				0x000581b4
#define IMX51_IPU_COMMON_DC_LLA1_REG				0x000581b8
#define IMX51_IPU_COMMON_DC_R_LLA0_REG				0x000581bc
#define IMX51_IPU_COMMON_DC_R_LLA1_REG				0x000581c0
#define IMX51_IPU_COMMON_DC_WR_CH_ADDR_5_ALT_REG		0x000581c4
#define IMX51_IPU_COMMON_DC_STAT_REG				0x000581c8
#define IMX51_IPU_COMMON_DMFC_RD_CHAN_REG			0x00060000
#define IMX51_IPU_COMMON_DMFC_WR_CHAN_REG			0x00060004
#define IMX51_IPU_COMMON_DMFC_WR_CHAN_DEF_REG			0x00060008
#define IMX51_IPU_COMMON_DMFC_DP_CHAN_REG			0x0006000c
#define IMX51_IPU_COMMON_DMFC_DP_CHAN_DEF_REG			0x00060010
#define IMX51_IPU_COMMON_DMFC_GENERAL1_REG			0x00060014
#define IMX51_IPU_COMMON_DMFC_GENERAL2_REG			0x00060018
#define IMX51_IPU_COMMON_DMFC_IC_CTRL_REG			0x0006001c
# define IMX51_IPU_COMMON_DMFC_IC_CTRL_IN_PORT(n)		((n) & 7)
#define IMX51_IPU_COMMON_DMFC_WR_CHAN_ALT_REG			0x00060020
# define IMX51_IPU_COMMON_DMFC_WR_CHAN_ALT_BURST_SIZE_2_ALT	((n) << 14)
# define IMX51_IPU_COMMON_DMFC_WR_CHAN_ALT_FIFO_SIZE_2_ALT(n)	((n) << 11)
# define IMX51_IPU_COMMON_DMFC_WR_CHAN_ALT_ST_ADDR_2_ALT(n)	((n) << 8)


#define IMX51_IPU_COMMON_DMFC_WR_CHAN_DEF_ALT_REG		0x00060024
#define IMX51_IPU_COMMON_DMFC_DP_CHAN_ALT_REG			0x00060028
#define IMX51_IPU_COMMON_DMFC_DP_CHAN_DEF_ALT_REG		0x0006002c
#define IMX51_IPU_COMMON_DMFC_GENERAL1_ALT_REG			0x00060030
#define IMX51_IPU_COMMON_DMFC_STAT_REG				0x00060034
#define IMX51_IPU_COMMON_VDI_FSIZE_REG				0x00068000
#define IMX51_IPU_COMMON_VDI_C_REG				0x00068004


#define IMX51_IPU_SRM_OFFSET		0x0f040000	/* = PA:0x4F040000 */
#define IMX51_IPU_SRM_SIZE		0x00001000
#define IMX51_IPU_SRM_DP_COM_CONF_SYNC_REG			0x00000000
# define IMX51_IPU_SRM_DP_COM_CONF_SYNC_FG_EN_SYNC		__BIT(0)
# define IMX51_IPU_SRM_DP_COM_CONF_SYNC_GWSEL_SYNC		__BIT(1)
# define IMX51_IPU_SRM_DP_COM_CONF_SYNC_GWAM_SYNC		__BIT(2)
# define IMX51_IPU_SRM_DP_COM_CONF_SYNC_GWCKE_SYNC		__BIT(3)
# define IMX51_IPU_SRM_DP_COM_CONF_SYNC_COC_SYNC(n)		(((n) & 7) << 4)
# define IMX51_IPU_SRM_DP_COM_CONF_SYNC_CSC_DEF_SYNC(n)		(((n) & 3) << 8)
# define IMX51_IPU_SRM_DP_COM_CONF_SYNC_CSC_GAMUT_SAT_EN_SYNC	__BIT(10)
# define IMX51_IPU_SRM_DP_COM_CONF_SYNC_SC_YUV_SAT_MODE_SYNC	__BIT(11)
# define IMX51_IPU_SRM_DP_COM_CONF_SYNC_GAMMA_EN_SYNC		__BIT(12)
# define IMX51_IPU_SRM_DP_COM_CONF_SYNC_GAMMA_YUV_EN_SYNC	__BIT(13)
#define IMX51_IPU_SRM_DP_GRAPH_WIND_CTRL_SYNC_REG		0x00000004
#define IMX51_IPU_SRM_DP_FG_POS_SYNC_REG			0x00000008
#define IMX51_IPU_SRM_DP_CUR_POS_SYNC_REG			0x0000000c
#define IMX51_IPU_SRM_DP_CUR_MAP_SYNC_REG			0x00000010
#define IMX51_IPU_SRM_DP_GAMMA_C_SYNC_0_REG			0x00000014
#define IMX51_IPU_SRM_DP_GAMMA_C_SYNC_1_REG			0x00000018
#define IMX51_IPU_SRM_DP_GAMMA_C_SYNC_2_REG			0x0000001c
#define IMX51_IPU_SRM_DP_GAMMA_C_SYNC_3_REG			0x00000020
#define IMX51_IPU_SRM_DP_GAMMA_C_SYNC_4_REG			0x00000024
#define IMX51_IPU_SRM_DP_GAMMA_C_SYNC_5_REG			0x00000028
#define IMX51_IPU_SRM_DP_GAMMA_C_SYNC_6_REG			0x0000002c
#define IMX51_IPU_SRM_DP_GAMMA_C_SYNC_7_REG			0x00000030
#define IMX51_IPU_SRM_DP_GAMMA_S_SYNC_0_REG			0x00000034
#define IMX51_IPU_SRM_DP_GAMMA_S_SYNC_1_REG			0x00000038
#define IMX51_IPU_SRM_DP_GAMMA_S_SYNC_2_REG			0x0000003c
#define IMX51_IPU_SRM_DP_GAMMA_S_SYNC_3_REG			0x00000040
#define IMX51_IPU_SRM_DP_CSCA_SYNC_0_REG			0x00000044
#define IMX51_IPU_SRM_DP_CSCA_SYNC_1_REG			0x00000048
#define IMX51_IPU_SRM_DP_CSCA_SYNC_2_REG			0x0000004c
#define IMX51_IPU_SRM_DP_CSCA_SYNC_3_REG			0x00000050
#define IMX51_IPU_SRM_DP_CSC_SYNC_0_REG				0x00000054
#define IMX51_IPU_SRM_DP_CSC_SYNC_1_REG				0x00000058
#define IMX51_IPU_SRM_DP_CUR_POS_ALT_REG			0x0000005c
#define IMX51_IPU_SRM_DP_COM_CONF_ASYNC0_REG			0x00000060
#define IMX51_IPU_SRM_DP_GRAPH_WIND_CTRL_ASYNC0			0x00000064
#define IMX51_IPU_SRM_DP_FG_POS_ASYNC0				0x00000068
#define IMX51_IPU_SRM_DP_CUR_POS_ASYNC0				0x0000006c
#define IMX51_IPU_SRM_DP_CUR_MAP_ASYNC0				0x00000070
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC0_0			0x00000074
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC0_1			0x00000078
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC0_2			0x0000007c
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC0_3			0x00000080
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC0_4			0x00000084
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC0_5			0x00000088
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC0_6			0x0000008c
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC0_7			0x00000090
#define IMX51_IPU_SRM_DP_GAMMA_S_ASYNC0_0			0x00000094
#define IMX51_IPU_SRM_DP_GAMMA_S_ASYNC0_1			0x00000098
#define IMX51_IPU_SRM_DP_GAMMA_S_ASYNC0_2			0x0000009c
#define IMX51_IPU_SRM_DP_GAMMA_S_ASYNC0_3			0x000000a0
#define IMX51_IPU_SRM_DP_CSCA_ASYNC0_0				0x000000a4
#define IMX51_IPU_SRM_DP_CSCA_ASYNC0_1				0x000000a8
#define IMX51_IPU_SRM_DP_CSCA_ASYNC0_2				0x000000ac
#define IMX51_IPU_SRM_DP_CSCA_ASYNC0_3				0x000000b0
#define IMX51_IPU_SRM_DP_CSC_ASYNC0_0				0x000000b4
#define IMX51_IPU_SRM_DP_CSC_ASYNC0_1				0x000000b8
#define IMX51_IPU_SRM_DP_COM_CONF_ASYNC1			0x000000bc
#define IMX51_IPU_SRM_DP_GRAPH_WIND_CTRL_ASYNC1			0x000000c0
#define IMX51_IPU_SRM_DP_FG_POS_ASYNC1				0x000000c4
#define IMX51_IPU_SRM_DP_CUR_POS_ASYNC1				0x000000c8
#define IMX51_IPU_SRM_DP_CUR_MAP_ASYNC1_REG			0x000000cc
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC1_0_REG			0x000000d0
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC1_1_REG			0x000000d4
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC1_2_REG			0x000000d8
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC1_3_REG			0x000000dc
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC1_4_REG			0x000000e0
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC1_5_REG			0x000000e4
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC1_6_REG			0x000000e8
#define IMX51_IPU_SRM_DP_GAMMA_C_ASYNC1_7_REG			0x000000ec
#define IMX51_IPU_SRM_DP_GAMMA_S_ASYNC1_0_REG			0x000000f0
#define IMX51_IPU_SRM_DP_GAMMA_S_ASYNC1_1_REG			0x000000f4
#define IMX51_IPU_SRM_DP_GAMMA_S_ASYNC1_2_REG			0x000000f8
#define IMX51_IPU_SRM_DP_GAMMA_S_ASYNC1_3_REG			0x000000fc
#define IMX51_IPU_SRM_DP_CSCA_ASYNC1_0_REG			0x00000100
#define IMX51_IPU_SRM_DP_CSCA_ASYNC1_1_REG			0x00000104
#define IMX51_IPU_SRM_DP_CSCA_ASYNC1_2_REG			0x00000108
#define IMX51_IPU_SRM_DP_CSCA_ASYNC1_3_REG			0x0000010c
#define IMX51_IPU_SRM_DP_CSC_ASYNC1_0_REG			0x00000110
#define IMX51_IPU_SRM_DP_CSC_ASYNC1_1_REG			0x00000114


#define IMX51_IPU_CPMEM_OFFSET		0x0f000000	/* = PA:0x4F000000 */
#define IMX51_IPU_CPMEM_SIZE		0x00020000

#define IMX51_IPU_CPMEM_CHANNELS	80
struct imx51_ipu_cpmem {
	/*
	 * 2 CPMEM Entries per An IDMAC channel.
	 * Each CPMEM Entry is 160(5x32)bit.
	 * Next CPMEM Entry starts next 256(8x32)bit.
	 */
	struct cpmem_entry {
		struct {
			uint32_t data[5];
			uint32_t stub[3];
		} cpe_word[2];
	} cpmem_entry[IMX51_IPU_CPMEM_CHANNELS];
};

#define CPMEM_ENTRY_ZERO(entry)						\
	memset(entry, 0, sizeof(struct cpmem_entry))

#define CPMEM_ENTRY_SET(entry, word, offset, width, v)			\
	do {								\
		int idx, off;						\
		idx = (offset) / 32;					\
		off = (offset) % 32;					\
		(entry)->cpe_word[word].data[idx] |= ((v) << off);	\
		if ((off + (width)) > 32) {				\
			(entry)->cpe_word[word].data[idx + 1] |=	\
			    ((v) >> (32 - off));			\
		}							\
	} while (0 /* CONSTCOND */)

#define CPMEM_ENTRY_CLR(entry, word, offset, width)			\
	do {								\
		int idx, off;						\
		uint32_t mask;						\
		mask = (1UL << (width)) - 1;				\
		idx = (offset) / 32;					\
		off = (offset) % 32;					\
		(entry)->cpe_word[word].data[idx] &= (mask << off);	\
		if ((off + (width)) > 32) {				\
			(entry)->cpe_word[word].data[idx + 1] &=	\
			    (mask >> (32 - off));			\
		}							\
	} while (0 /* CONSTCOND */)

#define CPMEM_ENTRY_GET(entry, word, offset, width, var)		\
	do {								\
		int idx, off;						\
		uint32_t mask;						\
		mask = (1UL << (width)) - 1;				\
		idx = (offset) / 32;					\
		off = (offset) % 32;					\
		(var) = ((entry)->cpe_word[word].data[idx] >> off);	\
		if ((off + (width)) > 32) {				\
			var |= ((entry)->cpe_word[word].data[idx + 1]	\
			    << (32 - off));				\
		}							\
		(var) &= mask;						\
	} while (0 /* CONSTCOND */)



/*
 * e.g.)
 *   struct cpmem *cpmem;
 *   CPMEM_ENTRY_SET(cpmem[ch], 0, 19, 96, 0x1234);
 */




/*
 * IDMAC Channels
 */
#define IDMAC_CH_SCI_FMEM_0			0
#define IDMAC_CH_SCI_FMEM_1			1
#define IDMAC_CH_SCI_FMEM_2			2
#define IDMAC_CH_SCI_FMEM_3			3
#define IDMAC_CH_VDI_BMEM			5	/* or VDI_IC */
#define IDMAC_CH_FMEM_VDI_PREVIOUS		8
#define IDMAC_CH_FMEM_VDI_CURRENT		9
#define IDMAC_CH_FMEM_VDI_NEXT			10
#define IDMAC_CH_BMEM_IC_POSTPROCESSING		11
#define IDMAC_CH_BMEM_IC_PrP_TASKS		12
#define IDMAC_CH_VDI_FMEM_RECENTFIELD		13
#define IDMAC_CH_FMEM_IC_PrP_TASK		14
#define IDMAC_CH_FMEM_IC_POSTPROCESSING		15
#define IDMAC_CH_FMEM_IC_TRANSPARENCY_14	17
#define IDMAC_CH_FMEM_IC_TRANSPARENCY_15	18
#define IDMAC_CH_IC_BMEM_PREPROCESSING		20
#define IDMAC_CH_IC_BMEM2_PREPROCESSING		21	/* or IC_DMFC */
#define IDMAC_CH_IC_BMEM_POSTPROCESSING		22
#define IDMAC_CH_FMEM_DP_PRIMARY_MAIN		23
#define IDMAC_CH_FMEM_DP_SECONDARY_MAIN		24
#define IDMAC_CH_FMEM_DP_PRIMARY_AUX		27
#define IDMAC_CH_FMEM_DC			28
#define IDMAC_CH_FMEM_DP_SECONDARY_AUX		29
#define IDMAC_CH_FMEM_DP_PRIMARY_TRANSPARENCY	31	/* for 27 */
#define IDMAC_CH_FMEM_DP_SECONDARY_TRANSPARENCY	33	/* for 29 */
#define IDMAC_CH_DC_FMEM			40
#define IDMAC_CH_FMEM_DC_ASYNC			41
#define IDMAC_CH_FMEM_DC_COMMAND1		42
#define IDMAC_CH_FMEM_DC_COMMAND2		43
#define IDMAC_CH_FMEM_DC_OUTPUTMASK		44
#define IDMAC_CH_BMEM_IRT_POSTENCODING		45
#define IDMAC_CH_BMEM_IRT_VIEWFINDER		46
#define IDMAC_CH_BMEM_IRT_POSTPROCESSING	47
#define IDMAC_CH_IRT_BMEM_ENCODING		48
#define IDMAC_CH_IRT_BMEM_VIEWFINDER		49
#define IDMAC_CH_IRT_BMEM_POSTPROCESSING	50
#define IDMAC_CH_FMEM_DP_PRIMARY_ALPHA		51	/* for 23 */
#define IDMAC_CH_FMEM_DP_SECONDARY_ALPHA	52	/* for 24 */


#define IMX51_IPU_LUT_OFFSET		0x0f020000	/* = PA:0x4f020000 */
#define IMX51_IPU_LUT_SIZE		0x00020000


#define IMX51_IPU_TPM_OFFSET		0x0f060000	/* = PA:0x4f060000 */
#define IMX51_IPU_TPM_SIZE		0x00020000


#define IMX51_IPU_DCTEMP_OFFSET		0x0f080000	/* = PA:0x4F080000 */
#define IMX51_IPU_DCTEMP_SIZE		0x00020000


#endif /* _ARM_IMX_IMX51_IPUREG_H_ */
